//TODO: solve flags count
//const int SORT_CHAPTER_1 = 1;
//const int SORT_CHAPTER_2 = 2;
//const int SORT_CHAPTER_3 = 4;
//const int SORT_CHAPTER_4 = 8;
//const int SORT_CHAPTER_5 = 16;
//const int SORT_CHAPTER_6 = 32;
//const int SORT_CHAPTER_7 = 64;
//
//const int SORT_ISLAND_VULCAN = 128;
//const int SORT_ISLAND_ARACHNID = 256;
//const int SORT_ISLAND_FORNAX = 512;
//const int SORT_ISLAND_TREASURE = BITF( 10 );
//const int SORT_ISLAND_OUTPOST = BITF( 11 );
//const int SORT_ISLAND_NEMESIS = BITF( 12 );
//const int SORT_ISLAND_EVERGREEN = BITF( 13 );
//const int SORT_ISLAND_BEACON = BITF( 14 );
//const int SORT_ISLAND_FRONTIER = BITF( 15 );
//const int SORT_ISLAND_GRANITE = BITF( 16 );
//const int SORT_ISLAND_VATTLAND = BITF( 17 );
//const int SORT_ISLAND_LINGARD = BITF( 18 );
//const int SORT_ISLAND_ISOLUS = BITF( 19 );
//const int SORT_ISLAND_FULCRUM = BITF( 20 );
//const int SORT_ISLAND_DUESSA = BITF( 21 );
//const int SORT_ISLAND_TERMINUS = BITF( 22 );
//const int SORT_ISLAND_ACHERON = BITF( 23 );
//const int SORT_ISLAND_MEDUSA = BITF( 24 );
//const int SORT_ISLAND_SANCTUARY = BITF( 25 );
//const int SORT_ISLAND_SOMNUS = BITF( 26 );
//const int SORT_ISLAND_NAIADES = BITF( 27 );
//const int SORT_ISLAND_BACCHUS = BITF( 28 );
//const int SORT_ISLAND_STYX = BITF( 29 );
//const int SORT_ISLAND_HADES = BITF( 30 );
//const int SORT_ISLAND_AVERNUS = BITF( 31 );
//const int SORT_ISLAND_MAGMA = BITF( 32 );
//const int SORT_ISLAND_THERMOPYLAE = BITF( 33 );
//const int SORT_ISLAND_MILESTONE = BITF( 34 );
//const int SORT_ISLAND_OBSIDIAN = BITF( 35 );
//const int SORT_ISLAND_GENETIX = BITF( 36 );

/** \addtogroup GameAPI */
/**@{*/
class GaeaMission_Campaign extends CCCampaign
{
	//randomize(-1);

	//Chapter defines
	const int CHAPTER_ZERO = 0;
	const int CHAPTER_ONE = 1;
	const int CHAPTER_TWO = 2;
	const int CHAPTER_THREE = 3;
	const int CHAPTER_FOUR = 4;

	// player shortcuts
	CCPlayer PlayerNeutral;
	CCPlayer PlayerUEC;
	CCPlayer PlayerAPA;

	int IslandsUEC;
	int IslandsAPA;

	float UnitSkill;
	float UnitSkillRange;
	int TechLvl;

	bool BanGameMessage;
	bool CampaignStart;


	/** \name Variables used in CC:GM Tutorial */
	//@{
	bool Tut_Car_adv_Tmwrp_Anderson;
	bool Tut_Car_adv_Tmwrp_SetDestination_Anderson;
	bool Tut_Car_adv_Tmwrp_Interrupted_Anderson;
	bool Tut_Car_adv_BasicDescription_Anderson;
	bool Tut_Car_Supplies;
	bool Tut_Car_Equip;
	bool Tut_Car_Move;
	bool Tut_Car_DefenseDrones;

	bool Tut_Com_adv_UnitSelect_Okoro;
	bool Tut_Com_UnitsAndLayout;
	bool Tut_Com_DockedUnit;
	bool Tut_Com_adv_Autopilot_Okoro;
	bool Tut_Com_adv_Armors_Okoro;

	bool Tut_Con_adv_Undock_Okoro;
	bool Tut_Con_adv_GetPlanned_Okoro;
	bool Tut_Con_adv_SuspendExec_Okoro;
	bool Tut_Con_adv_TurretsNextGun_Okoro;
	bool Tut_Con_adv_UnitStop;
	bool Tut_Con_GetPlanned;
	bool Tut_Con_Waypoint;
	bool Tut_Con_Dock;
	bool Tut_Con_MouseHold;

	bool Tut_Eqp_adv_Slots_Okoro;
	bool Tut_Eqp_adv_Filters_Okoro;

	bool Tut_Gen_adv_AIonIslands_Essi;
	bool Tut_Gen_adv_HackCC_Essi;
	bool Tut_Gen_adv_HackCCHacked_Essi;
	bool Tut_Gen_adv_ReplenisherRearm_Okoro;
	bool Tut_Gen_adv_ReplenisherHeal_Okoro;
	bool Tut_Gen_adv_Upgrades_Anderson;
	bool Tut_Gen_adv_CCDestroyed_Anderson;
	bool Tut_Gen_adv_CCBuild_Essi;
	bool Tut_Gen_adv_EnemyRadar_Okoro;
	bool Tut_Gen_adv_EnemyRadarDestroyed_Okoro;
	bool Tut_Gen_adv_upgrd_Equip_Okoro;
	bool Tut_Gen_ReplenisherFuel;
	bool Tut_Gen_RadarIconColours;
	bool Tut_Gen_1st3rdView;

	bool Tut_Cha_BasicControls;
	bool Tut_Cha_WeaponMode;
	bool Tut_Cha_AmmoReplenish;
	bool Tut_Cha_StealthBehaviour;
	bool Tut_Cha_Crouch;
	bool Tut_Cha_WalkRun;
	bool Tut_Cha_AutoHealSuite;
	bool Tut_Cha_Waypoint;
	bool Tut_Cha_MapCharMode;
	bool Tut_Cha_UseAction;

	bool Tut_Man_adv_HUD_Okoro;
	bool Tut_Man_adv_Controls_Anderson;
	bool Tut_Man_Controls;

	bool Tut_Wal_BasicControls;
	bool Tut_Wal_HUD;
	bool Tut_Wal_FuelLow;
	bool Tut_Wal_AmmoLow;

	bool Tut_Map_adv_FuelRadiusOfCarrier_Anderson;
	bool Tut_Map_adv_Slot_Anderson;
	bool Tut_Map_adv_Slot_Anderson_hint;
	bool Tut_Map_adv_Garage_Anderson;
	bool Tut_Map_OpenMapUsingControls;
	bool Tut_Map_EnemiesAndPlayersIslands;
	bool Tut_Map_TacticAndStrategicZoom;
	bool Tut_Map_IconOfCC;
	bool Tut_Map_IconOfTurret;

	bool Tut_Prs_adv_ProductionDescription_Anderson;
	bool Tut_Prs_adv_Factory_Anderson;
	bool Tut_Prs_adv_Minning_Anderson;
	bool Tut_Prs_adv_ProductionScreen_Anderson;
	bool Tut_Prs_adv_Defense_Anderson;
	bool Tut_Prs_adv_Stockpile_Anderson;

	bool Tut_FirstItemProduced;
	bool Tut_ProductionStarted;

	bool Tut_Rdm_adv_Assist_Okoro, Tut_Rdm_adv_Assist_Okoro2;
	bool Tut_Rdm_adv_Emergency_Okoro;
	bool Tut_Rdm_DockAll;
	bool Tut_Rdm_Offense;

	bool Tut_Rep_adv_Description_Anderson;
	bool Tut_Rep_adv_FuelConsumption_Anderson;
	bool Tut_Rep_adv_RepairZonePriority_Anderson;
	bool Tut_Rep_adv_RepairZoneChangePriority_Okoro;
	bool Tut_Rep_adv_NextRepZone_Okoro;
	bool Tut_Rep_RepairZonePriority_Okoro;

	bool Tut_Sps_adv_SuppliesScreen_Anderson;
	bool Tut_Sps_adv_SuppliesChain_Anderson;
	bool Tut_Sps_adv_IslandBonuses_Anderson;

	bool Tut_FirstBarqueSend;
	bool Tut_FirstBarqueArrived;

	bool Tut_Unt_adv_POI_Okoro;
	bool Tut_Unt_TargetSelect;

	bool Tut_IslandInfoEssiState, Tut_IslandInfoPlay, Tut_EquipPlay;
	int Tut_IslandInfoState, Tut_EquipState;

	//@}
	//End of Tutorial variable pool

	GameProduction ProductionUEC;
	GameProduction ProductionAPA;

	GameStorage CarrierStockUEC;
	GameStorage CarrierStockAPA;
	GameStorage StockPileUEC;
	GameStorage StockPileAPA;

	//! Island where is player
	IslandModel CurrentIsland;


	int CIII_ShinContact;

	bool CompleteObjectiveAfterCutscene;
	Objective WhichObjectiveToComplete;

	//Missions variable pool
	bool SkipChapter;
	bool CheatStart;

	int CurrentChapter;

	/** \name Variables used in CC:GM Research Centers */
	//@{
	bool RC_Finished_Lingard;
	bool RC_Finished_Vattland;
	bool RC_Finished_Isolus;
	bool RC_Finished_Bacchus;
	bool RC_Finished_Taksaven;

	int RC_FinishedCnt;
	int RC_FinishedCntGroupI;
	int RC_FinishedCntGroupIII;
	int SpecialBlueprintCnt;

	//@}

	/** \name Variables used in CC:GM Chapter II */
	//@{
	bool StartChapter_II;
	bool CII_CodeGainedI_Taksaven;
	bool CII_CodeGainedI_Missile;
	bool CII_CodeGainedII;
	bool CII_AuroraBack;
	bool CII_CountDownFinished;
	bool CII_CountDownStart;
	bool CII_BurnedGround;

	int CII_SpecialParts;
	int CII_ShinInfoState;
	int CII_BlueprintsGroupIICnt;

	float CII_CountDown;
	//@}

	/** \name Variables used in CC:GM Chapter III */
	//@{
	int IslandsAtFulcrum;
	int IslandsAfterFulcrum;
	int IslandAurora;
	int IslandsMarshes;
	int IslandTorpedoInfo;

	bool CIII_Torpedo1stPartGained;
	bool CIII_AuroraFound;
	bool CIII_AuroraFoundPart2;
	string CIII_MyrikHistory2Played;
	int CIII_VolcanicShields;
	//@}

	/** \name Obsolete Variables */
	//@{
	bool RestoreUnitsPositions;
	vector UnitsPositions[8];
	vector UnitsOrientations[8];
	int SelectedUnit;
	//@}

	/** \name Variables defined on CC:GM campaign start*/
	//@{
	string CII_HMHDMissileLoc;
	string CII_HMHDPlatformLoc;
	string CII_WalrusTurboLoc;
	string CII_MantaForsageLoc;

	string CIII_ShieldLoc1;
	string CIII_ShieldLoc2;
	string CIII_FirstVolcanicPlayed;

	string CIII_APACarrierLoc;

	string SpecialBlueprintLoc1;
	string SpecialBlueprintLoc2;
	string SpecialBlueprintLoc3;

	string CII_BlueprintsIslands[10];
	string CIII_BlueprintsIslands[7];

//	string UnitUpgradesIslands[2] = { "Granite", "Evergreen" };
//	string HammerPlatformIslands[2] = { "Taksaven", "Bacchus" };
//	string HammerMissilesIslands[3] = { "Vattland", "Lingard", "Isolus" };

	int CII_BlueprintsGroupI[5];
	int CII_BlueprintsGroupII[2];
	int CIII_BlueprintsGroup[7];

	int CII_ItemsGroupFactory[10];
	int CII_ItemsGroupRafinery[10];
	int CII_ItemsGroupDefense[10];

	int CIII_ItemsGroupFactory[10];
	int CIII_ItemsGroupRafinery[10];
	int CIII_ItemsGroupDefense[10];

	int ItemsGroupEmpty[10];

	//@}
	string RC_ACTIVATED[33];
 	string ActiveSlots[33];

	//must be set for cutscenes in Int_ControRoom world
	string WhichCutsceneToPlay;
	string WhichWorldToLoad;

	int RandomItem;

	bool BanPendingMessage;
	bool SelectCarrierAfterLoad;

 	int EvaluatingCarrierAttack;			//zamek na OnCarrierAttack, aby probihal pouze 1x a nevolal se nekolikrat

	//TEST:
	bool SpawnTurret;

	/** \name Objectives Arrays used in CC:GM */
	//@{
	Objective OBJECTIVES_CHAPTER_I[18];
	Objective OBJECTIVES_CHAPTER_II[8];
	Objective OBJECTIVES_CHAPTER_III[11];
	//@}

	/** \name Objectives Arrays used in CC:GM */
	//@{
	Objective q_DeadZone;
	Objective q_Chapter1;
	//@}

	/** \name Vulcan First Mission Objectives */
	//@{
	Objective q_Vulcan;
	Objective q_Vulcan_Explore;
	Objective q_Vulcan_JunkYard;
	Objective q_Vulcan_OldFacility;
	Objective q_Vulcan_Tunnel;
	Objective q_Vulcan_AssaultCC;
	Objective q_Vulcan_HackCC;
	Objective q_Vulcan_GetCarrier;
	//@}

	/** \name Arachnid First Mission Objectives */
	//@{
	Objective q_Arachnid;
	Objective q_ArachnidFactory;
	Objective q_ArachnidCC;
	Objective q_ArachnidLock;
	Objective q_ArachnidLocate;
	//@}

	/** \name Teasure First Mission Objectives */
	//@{
	Objective q_Treasure;
	Objective q_TreasureCC;
	Objective q_TreasureDeactivateDefense;
	Objective q_TreasureSlot;
	//@}

	/** \name Frontier First Mission Objectives */
	//@{
	Objective q_Frontier;
	Objective q_Frontier_Radar;
	Objective q_Frontier_CC;
	Objective q_Frontier_Build;
	Objective q_Frontier_Armor;
	//@}

	/** \name Outpost First Mission Objectives */
	//@{
	Objective q_Outpost;
	Objective q_Outpost_HackCC;
	Objective q_Outpost_FindFirewalls;
	Objective q_Outpost_Firewall2;
	Objective q_Outpost_Firewall1;
	Objective q_Outpost_OpenGate;
	//@}

	// chap 2
	Objective q_Chapter2;
	Objective qCII_UpgradeIcelands;
	Objective qCII_UpgradeTurbo;
	Objective qCII_UpgradeForsage;
	Objective qCII_TrackAurorasTeam;

	Objective qCII_SpecialBlueprint;

	Objective qCII_HMHD;
	Objective qCII_HMHDMissileLoc;
	Objective qCII_HMHDPlatformLoc;

	Objective qCII_FulcrumConq1st;
	Objective qCII_Fulcrum_CMS1;
	Objective qCII_Fulcrum_CMS2;
	Objective qCII_Fulcrum_SatStation;
	Objective qCII_Fulcrum_Shield;

	// chap 3
	Objective q_Chapter3;
	Objective qCIII_GetShin;
	Objective qCIII_DestroyRedDragon;
	Objective qCIII_TorpedoRocket;
	Objective qCIII_TorpedoSoftware;

	Objective qCIII_FindAurora;
	Objective qCIII_GetCard;
	Objective qCIII_UpgradeMarshes;
	Objective qCIII_UpgradeVolcanic;

	Objective qCIII_ThermopylaeConq1st;
	Objective qCIII_Thermopylae_Sector1;
	Objective qCIII_Thermopylae_Sector2;
	Objective qCIII_Thermopylae_Sector3;
	Objective qCIII_Thermopylae_Sector4;
	Objective qCIII_Thermopylae_Sector5;
	Objective qCIII_Thermopylae_Sector6;
	Objective qCIII_Thermopylae_SectorCC;
	Objective qCIII_Thermopylae_RC;

	Objective qCIII_ShieldThermopylae;
	Objective qCIII_ShieldFornax;
	Objective qCIII_FornaxCC;
	Objective qCIII_FornaxGrabContainer;
	Objective qCIII_ShieldMagma;
	Objective qCIII_MagmaCC;
	Objective qCIII_MagmaGrabContainer;
	Objective qCIII_ShieldAvernus;
	Objective qCIII_AvernusCC;
	Objective qCIII_AvernusGrabContainer;
	Objective qCIII_ShieldObsidian;
	Objective qCIII_ObsidianCC;
	Objective qCIII_ObsidianGrabContainer;

	// chap 4
	Objective q_DeadLock_GetMao;

	// 1stLayer Objectives
	//-----------------------------------------------------------

	Objective qCII_Evergreen1st;
	Objective qCII_Evergreen1stRand;
	Objective qCII_Evergreen_RC;
	Objective qCII_Nemesis1st;
	Objective qCII_Nemesis1stRand;
	Objective qCII_Nemesis_RC;
	Objective qCII_Beacon1st;
	Objective qCII_Beacon1stRand;
	Objective qCII_Beacon_RC;
	Objective qCII_Endymion1st;
	Objective qCII_Endymion1stRand;
	Objective qCII_Endymion_RC;

	Objective qCII_Bacchus1st;	
	Objective qCII_Bacchus_RC;
	Objective qCII_Bacchus_RC_Entry;
	Objective qCII_Bacchus_Survivors;
	Objective qCII_Bacchus_CCShield;

	Objective qCII_Taksaven1st;
	Objective qCII_Taksaven_RC;
	Objective qCII_Taksaven_AANests;
	Objective qCII_Taksaven_AAShields;
	Objective qCII_Taksaven_Artillery;

	Objective qCII_Granite1st;
	Objective qCII_Granite1stRand;
	Objective qCII_Granite_RC;

	Objective qCII_Vattland1st;
//	Objective qCII_Vattland1stRand;
	Objective qCII_Vattland_RC;
	Objective qCII_Vattland_Field;
	Objective qCII_Vattland_Panels;

	Objective qCII_Lingard1st;
	Objective qCII_Lingard1stRand;
	Objective qCII_Lingard_RC;
	Objective qCII_Isolus1st;
	Objective qCII_Isolus1stRand;
	Objective qCII_Isolus_RC;

	// Global Objectives
	//------------------------------------------------------------

	Objective q_TechExploration;

	Objective q_SpecialBlueprint;
	Objective q_SpecialBlueprintI;
	Objective q_SpecialBlueprintII;
	Objective q_SpecialBlueprintIII;

	Objective q_VulcanConq;
	Objective q_ArachnidConq;
	Objective q_TreasureConq;
	Objective q_FrontierConq;
	Objective q_OutpostConq;
	Objective q_NemesisConq;
	Objective q_EvergreenConq;
	Objective q_BeaconConq;
	Objective q_BacchusConq;
	Objective q_EndymionConq;
	Objective q_GraniteConq;
	Objective q_TaksavenConq;
	Objective q_VattlandConq;
	Objective q_LingardConq;
	Objective q_IsolusConq;

	Objective q_FulcrumConq;

	Objective q_NaiadesConq;
	Objective q_AvernusConq;
	Objective q_FornaxConq;
	Objective q_StyxConq;
	Objective q_HadesConq;
	Objective q_DuessaConq;
	Objective q_AcheronConq;
	Objective q_TerminusConq;
	Objective q_MedusaConq;
	Objective q_SanctuaryConq;
	Objective q_SomnusConq;
	Objective q_MagmaConq;
	Objective q_ObsidianConq;
	Objective q_MilestoneConq;
	Objective q_GenetixConq;
	Objective q_ThermopylaeConq;
	Objective q_DeadLockConq;

	Objective ISLANDS_OBJECTIVES[33];

	//-----------------------------------------------------------
	Objective q_VulcanConqRandom;
	Objective q_ArachnidConqRandom;
	Objective q_TreasureConqRandom;
	Objective q_FrontierConqRandom;
	Objective q_OutpostConqRandom;
	Objective q_NemesisConqRandom;
	Objective q_EvergreenConqRandom;
	Objective q_BeaconConqRandom;
	Objective q_FulcrumConqRandom;
	Objective q_BacchusConqRandom;
	Objective q_EndymionConqRandom;
	Objective q_GraniteConqRandom;
	Objective q_TaksavenConqRandom;
	Objective q_VattlandConqRandom;
	Objective q_LingardConqRandom;
	Objective q_IsolusConqRandom;
	Objective q_DuessaConqRandom;
	Objective q_AcheronConqRandom;
	Objective q_TerminusConqRandom;
	Objective q_MedusaConqRandom;
	Objective q_SanctuaryConqRandom;
	Objective q_SomnusConqRandom;
	Objective q_NaiadesConqRandom;
	Objective q_AvernusConqRandom;
	Objective q_FornaxConqRandom;
	Objective q_StyxConqRandom;
	Objective q_HadesConqRandom;
	Objective q_MagmaConqRandom;
	Objective q_MilestoneConqRandom;
	Objective q_IsolusConqRandom;
	Objective q_ObsidianConqRandom;
	Objective q_GenetixConqRandom;
	Objective q_ThermopylaeConqRandom;

	Objective ISLANDS_OBJECTIVES_RAND[33];

	/** \name Dialogs (advisors) played (through ActionQueue ) in CC:GM */
	//@{
	DialogAction dlg_CTSV_noUpgradeForIcelands;
	DialogAction dlg_CTSV_UpgradeForIcelands;
	DialogAction dlg_CTSV_chapII_ResearchCentre_noCode;
	DialogAction dlg_CTSV_chapII_ResearchCodeGained_noHMHD_v1;
	DialogAction dlg_CTSV_chapII_ResearchCodeGained_noHMHD_v2;
	DialogAction dlg_CTSV_chapII_ResearchCodeGained_noHMHD_v3;
	DialogAction dlg_CTSV_chapII_Supplybarque;
	DialogAction dlg_CTSV_chapII_BurnedGround;
	DialogAction dlg_CTSV_chapII_HMHDPlatformFound;
	DialogAction dlg_CTSV_chapII_HMHDMissileFound;
	DialogAction dlg_CTSV_chapII_HMHDNotFound;
	DialogAction dlg_CTSV_chapII_HMHDSystemCompleted;
	DialogAction dlg_CTSV_chapII_HMHDSystemNotCompleted;
	DialogAction dlg_CTSV_chapII_HMHDSystemNotCompleted2;
	DialogAction dlg_CTSV_chapII_MantaMediumArmorFound;
	DialogAction dlg_CTSV_chapII_ShinInfo1;
	DialogAction dlg_CTSV_chapII_ShinInfo2_v1;
	DialogAction dlg_CTSV_chapII_ShinInfo2_v2;
	DialogAction dlg_CTSV_chapII_ShinInfo2_v3;
	DialogAction dlg_CTSV_chapII_ShinInfo3;
	DialogAction dlg_CTSV_chapII_SpecialBlueprint;
	DialogAction dlg_CTSV_chapIII_TorpedoInfo1;
	DialogAction dlg_CTSV_chapIII_TorpedoInfo2;
	DialogAction dlg_CTSV_chapIII_MyrikHistory1;
	DialogAction dlg_CTSV_chapIII_ShinContactsMyrik;
	DialogAction dlg_CTSV_chapIII_TorpedoPart1Found;
	DialogAction dlg_CTSV_chapIII_noUpgradeForMarshes;
	DialogAction dlg_CTSV_chapIII_noUpgradeForVolcanic;
	DialogAction dlg_CTSV_chapIII_UpgradeForMarshes;
	DialogAction dlg_CTSV_chapIII_UpgradeForVolcanic;
	DialogAction dlg_CTSV_chapIII_DisableShieldNeeded;
	DialogAction dlg_CTSV_chapIII_FirstVolcanicMission;
	DialogAction dlg_FirstPowerPlantFound;
	DialogAction dlg_FirstShieldDefenceDisabled;
	DialogAction dlg_FourthShieldDefenceDisabled;
	DialogAction dlg_Gen_adv_AIonIslands_Essi;
	DialogAction dlg_con_adv_GetPlanned_Okoro;
	DialogAction dlg_con_adv_GetPlanned_Okoro_Joy;
	DialogAction dlg_adv_Tutorial_CarrierView_Anderson;
	DialogAction dlg_adv_Tutorial_CarrierView_Anderson_Joy;
	DialogAction dlg_adv_Tutorial_Map_TacticAndStrategicZoom2;

	DialogAction dlg_sps_adv_SuppliesScreen_Anderson02;
	DialogAction dlg_sps_adv_SuppliesScreen_Anderson02b;
	DialogAction dlg_sps_adv_SuppliesScreen_Anderson03;
	DialogAction dlg_sps_adv_SuppliesScreen_Anderson04;
	DialogAction dlg_sps_adv_SuppliesScreen_Anderson06b;
	DialogAction dlg_Iis_adv_IslandInfo_Anderson_03;
	DialogAction dlg_com_multiselect_auto_okoro;
	DialogAction dlg_whattodoinchapterii_okoro;	//po shinmeeting
	DialogAction dlg_whatTodoInChapteriii_myrik; // po ctsc Fulcrum Outro
	DialogAction dlg_adv_manualcarrierrepaired_anderson;
	//@}

	/** \name Sentences (advisors) played (through ActionQueue ) in CC:GM */
	//@{
	//SentenceAction dlg_sps_adv_SuppliesScreen_Anderson01;
	SentenceAction dlg_adv_Tutorial_Map_TacticAndStrategicZoom;
	SentenceAction dlg_con_adv_SuspendExec_Okoro, dlg_con_adv_LowFuel_Okoro, dlg_con_adv_LowAmmo_Okoro;
	SentenceAction dlg_adv_NoVolcanicMission;
	SentenceAction dlg_SecondShieldDefenceDisabled;
	SentenceAction dlg_ThirdShieldDefenceDisabled;
	SentenceAction dlg_CTSV_chapIII_SecondVolcanicMission;
	SentenceAction dlg_adv_Tutorial_SetSail;
	SentenceAction dlg_adv_Tutorial_SetSail_Joy;
	SentenceAction dlg_Car_adv_Tmwrp_Anderson;
	SentenceAction dlg_adv_Com_UnitsAndLayout, dlg_adv_Com_UnitsAndLayout2, dlg_adv_Com_UnitsAndLayout3, dlg_adv_Com_UnitsAndLayout4, dlg_adv_Com_UnitsAndLayout5;
	SentenceAction dlg_eqp_adv_slots_okoro_01, dlg_eqp_adv_slots_okoro_02,dlg_eqp_adv_slots_okoro_02b,dlg_eqp_adv_slots_okoro_02c,dlg_eqp_adv_slots_okoro_02d;
	SentenceAction dlg_prs_adv_ProductionDescription_Anderson01;

	SentenceAction dlg_Iis_adv_Info_Essi_00;
	SentenceAction dlg_Iis_adv_Info_Essi_01;
	SentenceAction dlg_Iis_adv_Info_Essi_02;
	SentenceAction dlg_Iis_adv_Info_Essi_03;
	SentenceAction dlg_Iis_adv_Info_Essi_04;
	SentenceAction dlg_Iis_adv_Info_Essi_05;
	SentenceAction dlg_Iis_adv_Info_Essi_06;

	SentenceAction dlg_prs_adv_ProductionDescription_Anderson02;
	SentenceAction dlg_prs_adv_ProductionDescription_Anderson02b;
	SentenceAction dlg_prs_adv_ProductionDescription_Anderson03a;
	SentenceAction dlg_prs_adv_ProductionDescription_Anderson03b;
	SentenceAction dlg_prs_adv_ProductionDescription_Anderson04;
	SentenceAction dlg_prs_adv_ProductionDescription_Anderson05;
	SentenceAction dlg_prs_adv_ProductionDescription_Anderson06;

	//---------RepairScreen----------------
	SentenceAction dlg_rep_adv_nextrepzone_okoro;
	SentenceAction dlg_rep_adv_description_anderson_02;
	SentenceAction dlg_rep_adv_description_anderson_02b;
	SentenceAction dlg_rep_adv_description_anderson_02c;
	SentenceAction dlg_rep_adv_description_anderson_02d;

	SentenceAction dlg_rep_adv_fuelconsumption_anderson_01;
	SentenceAction dlg_rep_adv_fuelconsumption_anderson_02;
	SentenceAction dlg_rep_repairzonepriority_okoro;

	SentenceAction dlg_rep_adv_repairzonechangepriority_okoro_01;
	SentenceAction dlg_rep_adv_repairzonepriority_anderson_01;
	SentenceAction dlg_rep_adv_repairzonepriority_anderson_02;
	SentenceAction dlg_rep_adv_repairzonechangepriority_okoro_02;

	SentenceAction dlg_prs_adv_Stockpile_Anderson;
	SentenceAction dlg_sps_adv_SuppliesScreen_Anderson05;
	SentenceAction dlg_sps_adv_SuppliesScreen_Anderson06;
	SentenceAction dlg_sps_adv_SuppliesScreen_Anderson07;

	SentenceAction dlg_Iis_adv_IslandInfo_Anderson_02;
	//SentenceAction dlg_Iis_adv_IslandInfo_Anderson_04a;
	//SentenceAction dlg_Iis_adv_IslandInfo_Anderson_04b;
	//SentenceAction dlg_Iis_adv_IslandInfo_Anderson_04c;
	SentenceAction dlg_Iis_adv_IslandInfo_Anderson_05;
	SentenceAction dlg_Iis_adv_IslandInfo_Anderson_06;

	SentenceAction dlg_CTSV_warningbeforesail_fulcrum;
	SentenceAction dlg_CTSV_warningaftersail_fulcrum;

	//--------------
	SentenceAction dlg_adv_islandalreadycatptured_okoro_01;

	SentenceAction dlg_adv_specialblueprint_part1_okoro_01;
	SentenceAction dlg_adv_specialblueprint_part2_okoro_01;
	SentenceAction dlg_adv_specialblueprint_part3_okoro_01;
	SentenceAction dlg_adv_specialblueprint_complete_okoro_01;
	
	SentenceAction dlg_rdm_waitforme;

	SentenceAction dlg_adv_forsage_anderson_01;
	SentenceAction dlg_adv_turbo_anderson_01;
	SentenceAction dlg_com_adv_autopilot_okoro;
	//@}

	/** \name Hints played through ActionQueue in CC:GM */
	//@{
	HintAction dlg_hint_Tutorial_MapViewIslandZoom;
	HintAction dlg_hint_Tutorial_MapViewIslandZoom_Joy;
	HintAction dlg_hint_Tutorial_ClickOnIsland;
	HintAction dlg_prs_ProductionDescription_01;
	HintAction dlg_sps_SuppliesScreen_Anderson01;

	//------Island Info
	HintAction dlg_Iis_Stockpile_02;
	HintAction dlg_Iis_IslandInfo_01;

	HintAction dlg_adv_car_hammerhead_okoro_01;
	HintAction hint_tut_hinthistory, unt_forsage_turbo_hint;

	//@}

		
	//! called every frame
	void OnUpdate( float timeSlice )
	{
		UpdateActionQueue(timeSlice);
		if ( dicurrenttime < 1 && g_Game.GetCurrentIsland().GetPlayer().GetID() == 1 )
			{
			for( int i = 1; i < 10 ; i++ )
				{
				EntityBasic assembly = g_Game.GetControlledPlayer().GetAssembly( i );
				int equipmentCount = 0;
				if ( assembly.GetEntity() != NULL && assembly.GetEntity().GetHealth() > 0 )
					{
					equipmentCount = assembly.GetEquipmentCount();
					for ( int y = 0; y < equipmentCount; y++ )
						{
						if ( assembly.GetEquipment( y ) == capsuleHack )
							{
							InteractiveEntity intEnt = assembly.GetEntity();
							vector ccPos = g_Game.GetCommandCenter().GetPosition();
							vector assPos = intEnt.GetPosition();
							vector v = ccPos - assPos;
							v[2] = 0;
							float dist = VectorLength(v);
							if ( dist < 1275 )
								{
								intEnt.ClearEquipment( capsuleHack );
								break;
								}
							}
						}
					}
				}
			}
	}

/*
	void SaveUnitsPositions()
	{
		RestoreUnitsPositions = true;
		EntityBasic assemblies[16];
		int numAssemblies = g_Game.GetControlledPlayer().GetAssemblies( assemblies );
		PlayerUEC.EnableCarrierMaintenance( false );

		for( int i = 0; i < numAssemblies; i++ )
		{
			EntityBasic assembly = assemblies[i];
			if ( assembly == NULL )
				continue;

			if( !assembly.IsDestroyed() && assembly.IsActive() )
			{
				InteractiveEntity ent = assembly.GetEntity();
				UnitsPositions[i] = ent.GetPosition();
				UnitsOrientations[i] = ent.GetOrientation();
				assembly.InstantDock();
			}

			InteractiveEntity unit = assembly.GetEntity();
			if ( unit != NULL && unit.IsSelected() )
				SelectedUnit = i;
		}	
	}

	void LoadUnitsPositions()
	{
		RestoreUnitsPositions = false;
		EntityBasic assemblies[16];
		int numAssemblies = g_Game.GetControlledPlayer().GetAssemblies( assemblies );

		for( int i = 0; i < sizeof( UnitsPositions ); i++ )
		{
			vector vec = UnitsPositions[i];
			if( vec == ZeroVec )
				continue;
			
			EntityBasic assembly = assemblies[i];
			vector angleTemp = UnitsOrientations[i];
			float angle = angleTemp[0];
			assembly.InstantDeploy( UnitsPositions[i], angle );
			UnitsPositions[i] = ZeroVec;
			UnitsOrientations[i] = ZeroVec;
		}

		if ( SelectedUnit > 0 )
		{
			InteractiveEntity unit = PlayerUEC.GetAssembly( SelectedUnit + 1 ).GetEntity();
			unit.SelectForPlayer();
		}
		else
			PlayerUEC.GetCarrier().SelectForPlayer();

		SelectedUnit = -1;
		PlayerUEC.EnableCarrierMaintenance( true );
	}
*/

//!
void DepleteCCHacker()
{
	for( int i = 1; i < 10 ; i++ )
	{
		EntityBasic assembly = g_Game.GetControlledPlayer().GetAssembly( i );
		int equipmentCount = 0;
		
		if ( assembly.GetEntity() != NULL )
		{
			if ( assembly.GetEntity().GetHealth() > 0 )		//jedina moznost jak zjistit, ze je jednotka dead, ponevadz assembly neni nikdy null
			{
				equipmentCount = assembly.GetEquipmentCount();
				for ( int y = 0; y < equipmentCount; y++ )
				{
					if ( assembly.GetEquipment( y ) == capsuleHack )
					{
						InteractiveEntity intEnt = assembly.GetEntity();
						vector ccPos = g_Game.GetCommandCenter().GetPosition();
						vector assPos = intEnt.GetPosition();

						vector v = ccPos - assPos;
						v[2] = 0;
						float dist = VectorLength(v);
						if ( dist < 1275 )
						{
							intEnt.DepleteCapsule();
							return;
						}
					}
				}
			}
		}
	}
}



//---------------------**************CUSCENES************************------------------------------------
//--------------------------------------------------------------------------------------------------------------------

	/** \name Cutscenes played in Control Room in CC:GM */
	//@{
	//----------------------------------------------------------------------------------------------------------------
	void Start_chapI_ShinMeeting( )
	{
		CampaignLog( "[CC:GM] >>> CTSC Shin Meeting - cca 11 sec delay", 4 );
		g_Game.FadeOut( 100 );
		g_Game.ResetLoadCounter();
		g_Game.EnableSaves( false );
		Sleep( 100 );
		didronedockforce = true;
		Wait ( !diincarrcutscene && !didrone );
		g_Game.EnableSaves( true );

		if( g_Game.GetLoadCounter() == 0 )
		{
//			PlayerUEC.InstatDockAllUnits();
			WhichWorldToLoad = "Outpost";
			WhichCutsceneToPlay = "ctsc_chapI_OutpostShinMeeting";
			g_Game.LoadCutScene("worlds/Int_ControlRoom_repaired.ent");
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void Start_chapII_AuroraBack( bool fadeOut, string island )
	{
		CampaignLog( "[CC:GM] >>> CTSC Aurora Back - checks for different starts.", 4 );
		if ( g_Game.GetCurrentIsland().GetPlayer() != PlayerUEC && fadeOut )
		{
			CampaignLog( "[CC:GM] >>> CTSC Aurora Back - nespoustej misi kdyz jsem na cizim ostrove", 4 );
			return;
		}

		CampaignLog( "[CC:GM] >>> CTSC Aurora Back - ted uz se opravdu spusti", 4 );
		CII_AuroraBack = true;
		g_Achievements.OnAuroraContact();

		if ( !CheatStart )
		{
			g_Game.ResetLoadCounter();
			if ( fadeOut )
			{
				int r = rand( 1,3 );
				r = r * 100;//convert to sleep units :)
				g_Game.FadeOut( r );
				g_Game.EnableSaves( false );
				Sleep(r);
				didronedockforce = true;
				Wait ( !diincarrcutscene && !didrone );
				g_Game.EnableSaves( true );
			}
			//PlayerUEC.InstatDockAllUnits();
			//SaveUnitsPositions();

			if( g_Game.GetLoadCounter() == 0 )
			{
				WhichCutsceneToPlay = "ctsc_chapII_AuroraBack";
				WhichWorldToLoad = island;
				g_Game.LoadCutScene("worlds/Int_ControlRoom_repaired.ent");
			}
		}

		qCII_HMHDMissileLoc.SetStatus( OBJECTIVE_PENDING );
		qCII_HMHDPlatformLoc.SetStatus( OBJECTIVE_PENDING );
		qCII_HMHD.SetStatus( OBJECTIVE_PENDING );
		qCII_FulcrumConq1st.SetStatus( OBJECTIVE_PENDING );
		//g_Game.FindIslandByName( "Fulcrum" ).EnableOnMap( true );
	}

	//-----------------------------------------------------------------------------------------------------------------
	void Start_chapII_ResearchCodeGained1()
	{
		CampaignLog( "[CC:GM]>>> CTSC Research Code Gained 1 - delay cca 2sec", 4 );
		if ( !CheatStart )
		{

Activator diact = FindNamedEntity( g_Game.CurrentWorld, "RC_Activator" );
diact.DisableUse();
diobjective.SetTitle(distring("#fulcrum_wp_returncarrier"));
diresetobjective = diobjective;
SetCurrentObjective(NULL);
Wait( !diobjective );
SetCurrentObjective(diresetobjective);
Wait ( !diisfullydeployed[1] && !diisfullydeployed[2] && !diisfullydeployed[3] && !diisfullydeployed[4] && !diisfullydeployed[5] && !diisfullydeployed[6] && !diisfullydeployed[7] && !diisfullydeployed[8] );
Wait ( !diincarrcutscene && !didrone );
diobjective.SetTitle("#obj_currentisland_title TAKSAVEN");
				diPlayerUEC.GetCarrierBasic().Stop();
				diPlayerUEC.SpawnCarrier ( g_Game.GetIsland(13), CarrierArmored, false );
			int r = rand( 1,3 );
			r = r * 100;//convert to sleep units :)
			g_Game.FadeOut( r );
			g_Game.ResetLoadCounter();
			g_Game.EnableSaves( false );
			Sleep(r);
			didronedockforce = true;
			g_Game.EnableSaves( true );

			if ( g_Game.GetLoadCounter() == 0 )
			{
//				PlayerUEC.InstatDockAllUnits();
				WhichCutsceneToPlay = "ctsc_chapII_ResearchCodeGained_v1";
				WhichWorldToLoad = g_Game.GetCurrentIsland().GetName();
				g_Game.LoadCutScene("worlds/Int_ControlRoom_repaired.ent");
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void Start_chapII_AuroraCaptured()
	{
		CampaignLog("[CC:GM]>>> CTSC Aurora Captured", 4 );

		int r = rand( 1,3 );
		r = r * 100;//convert to sleep units :)
		g_Game.FadeOut( r );
		g_Game.ResetLoadCounter();
		g_Game.EnableSaves( false );
		Sleep(r);
		didronedockforce = true;
		Wait ( !diincarrcutscene && !didrone );
		g_Game.EnableSaves( true );

		if ( g_Game.GetLoadCounter() == 0 )
		{
			//SaveUnitsPositions();
			WhichCutsceneToPlay = "ctsc_chapII_AuroraCaptured";
			WhichWorldToLoad = g_Game.GetCurrentIsland().GetName();
			g_Game.LoadCutScene("worlds/Int_ControlRoom_repaired.ent");
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void Start_chapII_FulcrumOutroA()
	{
		CampaignLog( "[CC:GM]>>> CTSC Fulcrum Outro A - delay cca 2sec", 4 );
		if ( !CheatStart )
		{
			int r = rand( 1,3 );
			r = r * 100;//convert to sleep units :)
			g_Game.FadeOut( r );
			g_Game.ResetLoadCounter();
			g_Game.EnableSaves( false );
			Sleep(r);
			didronedockforce = true;
			Wait ( !diincarrcutscene && !didrone );
			g_Game.EnableSaves( true );

			if ( g_Game.GetLoadCounter() == 0 )
			{
				WhichCutsceneToPlay = "ctsc_chapII_FulcrumOutroA";
				WhichWorldToLoad = g_Game.GetCurrentIsland().GetName();
				g_Game.LoadCutScene("worlds/Int_ControlRoom_repaired.ent");
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void Start_chapII_FulcrumOutroB()
	{
		CampaignLog( "[CC:GM]>>> CTSC Fulcrum Outro B - delay cca 2sec", 4 );
		if ( !CheatStart )
		{
			int r = rand( 1,3 );
			r = r * 100;//convert to sleep units :)
			g_Game.FadeOut( r );
			g_Game.ResetLoadCounter();
			g_Game.EnableSaves( false );
			Sleep(r);
			didronedockforce = true;
			Wait ( !diincarrcutscene && !didrone );
			g_Game.EnableSaves( true );

			if ( g_Game.GetLoadCounter() == 0 )
			{
				WhichCutsceneToPlay = "ctsc_chapII_FulcrumOutroB";
				WhichWorldToLoad = g_Game.GetCurrentIsland().GetName();
				g_Game.LoadCutScene("worlds/Int_ControlRoom_repaired.ent");
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void Start_chapIII_AuroraFoundPart1()
	{
		CampaignLog( "[CC:GM] >>> CTSC Aurora Found Part 1 - no delay", 4 );
		CIII_AuroraFound = true;

		if ( !CheatStart )
		{
			g_Game.FadeOut( 100 );
			g_Game.ResetLoadCounter();
			g_Game.EnableSaves( false );
			Sleep( 110 );
			didronedockforce = true;
			Wait ( !diincarrcutscene && !didrone );
			g_Game.EnableSaves( true );

			if ( g_Game.GetLoadCounter() == 0 )
			{
//				PlayerUEC.InstatDockAllUnits();

				WhichCutsceneToPlay = "ctsc_chapIII_AuroraFoundPart1";
				WhichWorldToLoad = g_Game.GetCurrentIsland().GetName();
				g_Game.LoadCutScene("worlds/Int_ControlRoom_repaired.ent");
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void Start_chapIII_AuroraFoundPart1b()
	{
		CampaignLog( "[CC:GM] >>> CTSC Aurora Found Part 1b - delay cca 2sec", 4 );
		if ( !CheatStart )
		{
			int r = rand( 1,2 );
			r = r * 100;//convert to sleep units :)
			g_Game.FadeOut( r );
			g_Game.ResetLoadCounter();
			g_Game.EnableSaves( false );
			Sleep(r);
			didronedockforce = true;
			Wait ( !diincarrcutscene && !didrone );
			g_Game.EnableSaves( true );

			if ( g_Game.GetLoadCounter() == 0 )
			{
				WhichCutsceneToPlay = "ctsc_chapIII_AuroraFoundPart1b";
				WhichWorldToLoad = g_Game.GetCurrentIsland().GetName();
				g_Game.LoadCutScene("worlds/Int_ControlRoom_repaired.ent");
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void Start_chapIII_AuroraFoundPart2()
	{
		CampaignLog( "[CC:GM] >>> CTSC Aurora Found Part 2 - delay cca 2sec", 4 );
		CIII_AuroraFoundPart2 = true;
		if ( !CheatStart )
		{
			int r = rand( 1,3 );
			r = r * 100;//convert to sleep units :)
			g_Game.FadeOut( r );
			g_Game.ResetLoadCounter();
			g_Game.EnableSaves( false );
			Sleep(r);
			didronedockforce = true;
			Wait ( !diincarrcutscene && !didrone );
			g_Game.EnableSaves( true );

			if ( g_Game.GetLoadCounter() == 0 )
			{
//				PlayerUEC.InstatDockAllUnits();

				WhichCutsceneToPlay = "ctsc_chapIII_AuroraFoundPart2";
				WhichWorldToLoad = g_Game.GetCurrentIsland().GetName();
				g_Game.LoadCutScene("worlds/Int_MedicalRoom.ent");
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void Start_chapIII_MyrikHistory2()
	{
		CampaignLog( "[CC:GM] >>> CTSC Myrik History 2 - delay cca 2sec", 4 );
		CIII_MyrikHistory2Played = g_Game.GetCurrentIsland().GetName();
		if ( !CheatStart )
		{
			int r = rand( 1,3 );
			r = r * 100;//convert to sleep units :)
			g_Game.FadeOut( r );
			g_Game.ResetLoadCounter();
			g_Game.EnableSaves( false );
			Sleep(r);
			didronedockforce = true;
			Wait ( !diincarrcutscene && !didrone );
			g_Game.EnableSaves( true );

			if ( g_Game.GetLoadCounter() == 0 )
			{
//				PlayerUEC.InstatDockAllUnits();

				WhichCutsceneToPlay = "ctsc_chapIII_MyrikHistory";
				WhichWorldToLoad = g_Game.GetCurrentIsland().GetName();
				g_Game.LoadCutScene("worlds/Int_MedicalRoom.ent");
			}
		}
	}

	//@}


	/** \name Cutscenes played as Advisors with some improvements  CC:GM */
	//@{
	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_noUpgradeForIcelands()
	{
		CampaignLog( "[CC:GM] >>> CTSV No Upgrade For Icelands - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_noUpgradeForIcelands.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_UpgradeForIcelands()
	{
		CampaignLog( "[CC:GM] >>> CTSV Upgrade For Icelands Gained - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_UpgradeForIcelands.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_ResearchCentre_noCode()
	{
		CampaignLog( "[CC:GM] >>> CTSV ResearchCentre_noCode - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapII_ResearchCentre_noCode.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_ResearchCodeGained_noHMHD()
	{
		CampaignLog( "[CC:GM] >>> CTSV ResearchCodeGained_noHMHD - check fo diffenrt cutscenes", 4 );
		if ( !CheatStart )
		{
			float r = frand( 0,1 );
			if ( r < 0.33 )
				dlg_CTSV_chapII_ResearchCodeGained_noHMHD_v1.ToQueue();
			else
			{
				if ( r <= 0.66 )
					dlg_CTSV_chapII_ResearchCodeGained_noHMHD_v2.ToQueue();
				else
					dlg_CTSV_chapII_ResearchCodeGained_noHMHD_v3.ToQueue();
			}
		}
	}
	
	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_Supplybarque()
	{
		CampaignLog( "[CC:GM] >>> CTSV Supply barque - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapII_Supplybarque.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_BurnedGround()
	{
		CII_BurnedGround = true;
		CampaignLog( "[CC:GM] >>> CTSV Burned ground - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapII_BurnedGround.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_HMHDPlatformFound()
	{
		CampaignLog( "[CC:GM] >>> CTSV Platform found - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapII_HMHDPlatformFound.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_HMHDMissileFound()
	{
		CampaignLog( "[CC:GM] >>> CTSV Missile found - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapII_HMHDMissileFound.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_HMHDNotFound()
	{
		CampaignLog( "[CC:GM] >>> CTSV HMHD NOT found - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapII_HMHDNotFound.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_HMHDSystemCompleted()
	{
		CampaignLog( "[CC:GM] >>> CTSV HMHD system completed - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapII_HMHDSystemCompleted.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_HMHDSystemNotCompleted()
	{
		CampaignLog( "[CC:GM] >>> CTSV HMHD system completed - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapII_HMHDSystemNotCompleted.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_HMHDSystemNotCompleted2()
	{
		CampaignLog( "[CC:GM] >>> CTSV HMHD system not completed2 - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapII_HMHDSystemNotCompleted2.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_MantaMediumArmorFound()
	{
		CampaignLog( "[CC:GM] >>> CTSV Manta Medium Armor Found - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapII_MantaMediumArmorFound.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_ShinInfo1()
	{
		CampaignLog( "[CC:GM] >>> CTSV Shin Info 1 - no delay", 4 );
		CII_ShinInfoState = 1;
		if ( !CheatStart )
			dlg_CTSV_chapII_ShinInfo1.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_ShinInfo2()
	{
		CampaignLog( "[CC:GM] >>> CTSV Shin Info 2 - check for different cutscenes ", 4 );
		CII_ShinInfoState = 2;
		if ( !CheatStart )
		{
			if ( qCII_HMHD.GetStatus() == OBJECTIVE_COMPLETE )
				dlg_CTSV_chapII_ShinInfo2_v1.ToQueue();
			else
			{
				if ( qCII_HMHDPlatformLoc.GetStatus() == OBJECTIVE_COMPLETE || qCII_HMHDMissileLoc.GetStatus() == OBJECTIVE_COMPLETE )
					dlg_CTSV_chapII_ShinInfo2_v2.ToQueue();
				else
					dlg_CTSV_chapII_ShinInfo2_v3.ToQueue();
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapII_ShinInfo3( bool auroraCaptured )
	{
		CampaignLog( "[CC:GM] >>> CTSV Shin Info 3 - no delay", 4 );
		CII_ShinInfoState = 3;
		if ( !CheatStart )
		{
			dlg_CTSV_chapII_ShinInfo3.ToQueue();
			if ( auroraCaptured )
			{
				Wait( dlg_CTSV_chapII_ShinInfo3.IsFinished() )
					thread Start_chapII_AuroraCaptured();
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapIII_TorpedoInfo1()
	{
		CampaignLog( "[CC:GM] >>> CTSV Torpedo Info 1 - no delay", 4 );
		IslandTorpedoInfo += 1;
		if ( !CheatStart )
			dlg_CTSV_chapIII_TorpedoInfo1.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapIII_TorpedoInfo2()
	{
		CampaignLog( "[CC:GM] >>> CTSV Torpedo Info 2 - no delay", 4 );
		IslandTorpedoInfo += 1;
		if ( !CheatStart )
			dlg_CTSV_chapIII_TorpedoInfo2.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapIII_MyrikHistory1()
	{
		CampaignLog( "[CC:GM] >>> CTSV Myrik History 1 - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapIII_MyrikHistory1.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapIII_ShinContactsMyrik()
	{
		CampaignLog( "[CC:GM] >>> CTSV Shin Contacts Myrik - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapIII_ShinContactsMyrik.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapIII_TorpedoPart1Found()
	{
		CampaignLog( "[CC:GM] >>> CTSV Torpedo Part 1 - no delay", 4 );
		CIII_Torpedo1stPartGained = true;
		if ( !CheatStart )
			dlg_CTSV_chapIII_TorpedoPart1Found.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapIII_noUpgradeForMarshes()
	{
		CampaignLog( "[CC:GM] >>> CTSV No Upgrade for Marshes - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapIII_noUpgradeForMarshes.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapIII_noUpgradeForVolcanic()
	{
		CampaignLog( "[CC:GM] >>> CTSV No Upgrade for Volcanic - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapIII_noUpgradeForVolcanic.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapIII_UpgradeForMarshes()
	{
		CampaignLog( "[CC:GM] >>> CTSV Upgrade for Marshes Gained - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapIII_UpgradeForMarshes.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapIII_UpgradeForVolcanic()
	{
		CampaignLog( "[CC:GM] >>> CTSV Upgrade for Volcanic Gained - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapIII_UpgradeForVolcanic.ToQueue();
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CTSV_chapIII_DisableShieldNeeded()
	{
		CampaignLog( "[CC:GM] >>> CTSV Disable Shield Needed - no delay", 4 );
		if ( !CheatStart )
			dlg_CTSV_chapIII_DisableShieldNeeded.ToQueue();
	}
	//@}

	void RemoveSentenceAddToShiplog( SentenceAction action )
	{
		if ( action.InMainQueue() && !action.IsPlaying() )
		{
			string dialogID = action.text;
			g_ActionQueue.RemoveAction( action );
			g_Game.AddMessage( dialogID, -1, LMF_ADVISOR );
		}

		if ( action.IsPlaying() )
			action.Stop();
	}

	void RemoveIslandInfoTutorial()
	{
		RemoveSentenceAddToShiplog( dlg_Iis_adv_Info_Essi_01 );
		RemoveSentenceAddToShiplog( dlg_Iis_adv_Info_Essi_02 );
		RemoveSentenceAddToShiplog( dlg_Iis_adv_Info_Essi_03 );
		RemoveSentenceAddToShiplog( dlg_Iis_adv_Info_Essi_04 );
		RemoveSentenceAddToShiplog( dlg_Iis_adv_Info_Essi_05 );
		RemoveSentenceAddToShiplog( dlg_Iis_adv_Info_Essi_06 );

		g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );
	}

	void RemoveRepairTutorial()
	{
		RemoveSentenceAddToShiplog( dlg_rep_adv_description_anderson_02 );
		RemoveSentenceAddToShiplog( dlg_rep_adv_description_anderson_02b );
		RemoveSentenceAddToShiplog( dlg_rep_adv_description_anderson_02c );
		RemoveSentenceAddToShiplog( dlg_rep_adv_description_anderson_02d );
		RemoveSentenceAddToShiplog( dlg_rep_adv_fuelconsumption_anderson_01 );
		RemoveSentenceAddToShiplog( dlg_rep_adv_fuelconsumption_anderson_02 );
		RemoveSentenceAddToShiplog( dlg_rep_repairzonepriority_okoro );

		g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );
	}

	void RemoveProductionTutorial()
	{
		RemoveSentenceAddToShiplog( dlg_prs_adv_ProductionDescription_Anderson02 );
		RemoveSentenceAddToShiplog( dlg_prs_adv_ProductionDescription_Anderson02b );
		RemoveSentenceAddToShiplog( dlg_prs_adv_ProductionDescription_Anderson03a );
		RemoveSentenceAddToShiplog( dlg_prs_adv_ProductionDescription_Anderson03b );
		RemoveSentenceAddToShiplog( dlg_prs_adv_ProductionDescription_Anderson04 );
		RemoveSentenceAddToShiplog( dlg_prs_adv_ProductionDescription_Anderson05 );

		g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );
	}

//---------------------^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^-------------------------------------
//--------------------------------------------------------------------------------------------------------------------


	//SLOTS ACTIVATION FUNCTIONS

	//-----------------------------------------------------------------------------------------------------------------
	void SlotActivatorInit( Activator activator, string islandName )
	{
		activator.DisableUse();
		activator.EnableCammoRemap();
		for( int i = 0; i < sizeof( ActiveSlots ); i++ )
		{
			if ( islandName != ActiveSlots[i] ) continue;

			activator.EnableUse();
			activator.DisableCammoRemap();
			break;
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void SlotActivatorUsed( Activator activator, string islandName )
	{
		activator.DisableUse();
		activator.EnableCammoRemap();
		for( int i = 0; i < sizeof( ActiveSlots ); i++ )
		{
			if ( islandName == "" ) continue;
			if ( islandName == ActiveSlots[i] )
			{
				ActiveSlots[i] = "";
				break;
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void SlotRestoration( string islandName )
	{
		bool alreadyActive = false;
		
		for( int k = 0; k < sizeof( ActiveSlots ); k++ )
		{
			//check - asi nejaka chyba, nemel by v seznamu byt uveden
			if ( islandName == ActiveSlots[k] )
				return;
		}

		if ( !alreadyActive )
		{
			for ( k = 0; k < sizeof( ActiveSlots ); k++ )
			{
				if ( ActiveSlots[k] == "" )
				{
					ActiveSlots[k]= islandName;
					break;
				}
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void SpecialBlueprintActivated( string islandName )
	{
		if ( q_SpecialBlueprint.GetStatus() == OBJECTIVE_UNAVAILABLE )
			q_SpecialBlueprint.SetStatus( OBJECTIVE_PENDING )

		if ( islandName == SpecialBlueprintLoc1 && !g_Game.IsObjectiveCompleted( q_SpecialBlueprintI ) )
		{
			SpecialBlueprintCnt += 1;
			g_Game.ForceObjectiveComplete( q_SpecialBlueprintI );
			return;
		}
		
		if ( islandName == SpecialBlueprintLoc2 && !g_Game.IsObjectiveCompleted( q_SpecialBlueprintII ) )
		{
			SpecialBlueprintCnt += 1;
			g_Game.ForceObjectiveComplete( q_SpecialBlueprintII );
			return;
		}

		if ( islandName == SpecialBlueprintLoc3 && !g_Game.IsObjectiveCompleted( q_SpecialBlueprintIII ) )
		{
			SpecialBlueprintCnt += 1;
			g_Game.ForceObjectiveComplete( q_SpecialBlueprintIII );
			return;
		}
		
		g_Game.PlayGameSound( "fx/vattland/hovercraft_stop" );
	}

	//RC ACTIVATION FUNCTIONS

	//-----------------------------------------------------------------------------------------------------------------
	bool RC_IsActive( string islandName )
	{
		if ( q_Chapter1.GetStatus() == OBJECTIVE_PENDING )
			return false;

		for( int i = 0; i< sizeof( RC_ACTIVATED ); i++ )
		{
			if ( RC_ACTIVATED[i] == islandName )
				return false;
			if ( RC_ACTIVATED[i] == "")
				break;
		}

		if ( g_Game.GetCurrentIsland().GetPlayer() == PlayerUEC )
			return true;
		else
			return false;

	}

	//-----------------------------------------------------------------------------------------------------------------
	void RCActivatorInit( Activator activator, string islandName )
	{
		activator.DisableCammoRemap();

		if ( q_Chapter1.GetStatus() == OBJECTIVE_PENDING )
		{
			activator.DisableUse();
			return;
		}

		for( int i = 0; i< sizeof( RC_ACTIVATED ); i++ )
		{
			if ( RC_ACTIVATED[i] == islandName )
			{
				activator.EnableCammoRemap();
				activator.DisableUse();
				break;
			}
			
			if ( RC_ACTIVATED[i] == "")
				break;
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void SetCurrentTask( string islandName )
	{
		CampaignLog( "[CC:GM] >>> Setting Current task.", 6);
		IslandModel island = g_Game.GetCurrentIsland();

		if ( island.GetPlayer() == PlayerNeutral )
		{		
			SetCurrentObjective( UnipostHackCC );
			SetCurrentObjectiveShiplog( UnipostHackCC );
			PlayerUEC.SetNextWaypoint( "#obj_objective_cc_build",  g_Game.GetCommandCenter() );
			return;
		}

		if ( island.GetPlayer() == PlayerUEC )
		{
			if ( q_Chapter2.GetStatus() == OBJECTIVE_PENDING )
			{
				if ( RC_IsActive( islandName ) )
				{
					switch( islandName )
					{
						case "Evergreen":
							SetCurrentObjective( qCII_Evergreen_RC );
							SetCurrentObjectiveShiplog( qCII_Evergreen_RC );
							break;

						case "Nemesis":
							SetCurrentObjective( qCII_Nemesis_RC );
							SetCurrentObjectiveShiplog( qCII_Nemesis_RC );
							break;					

						case "Beacon":
							SetCurrentObjective( qCII_Beacon_RC );
							SetCurrentObjectiveShiplog( qCII_Beacon_RC );
							break;

						case "Endymion":
							SetCurrentObjective( qCII_Endymion_RC );
							SetCurrentObjectiveShiplog( qCII_Endymion_RC );
							break;

						case "Granite":
							SetCurrentObjective( qCII_Granite_RC );
							SetCurrentObjectiveShiplog( qCII_Granite_RC );
							break;

						case "Vattland":
							SetCurrentObjective( qCII_Vattland_RC );
							SetCurrentObjectiveShiplog( qCII_Vattland_RC );
							break;

						case "Lingard":
							SetCurrentObjective( qCII_Lingard_RC );
							SetCurrentObjectiveShiplog( qCII_Lingard_RC );
							break;

						case "Isolus":
							SetCurrentObjective( qCII_Isolus_RC );
							SetCurrentObjectiveShiplog( qCII_Isolus_RC );
							break;
					}
				}
				else
				{
					SetCurrentObjective( q_Chapter2 );
					SetCurrentObjectiveShiplog( q_Chapter2 );
				}
				return;
			}
		}
		else
		{
			if ( strstr( g_Game.SpawnLayerName( g_Game.GetSpawnLayer() ), "First") > 0 )
				return;

			//--------------------------------------------------
			//Setting Current Task For ChapterII
			if ( q_Chapter2.GetStatus() == OBJECTIVE_PENDING )
			{
				if ( CII_AuroraBack )
				{
					if ( IsObjectiveCompleted( qCII_HMHD ) )
					{
						SetCurrentObjective( qCII_FulcrumConq1st );
						SetCurrentObjectiveShiplog( qCII_FulcrumConq1st );
					}
					else
					{
						if ( IsObjectiveCompleted( qCII_HMHDPlatformLoc ) || IsObjectiveCompleted( qCII_HMHDMissileLoc ) )
						{
							if ( IsObjectiveCompleted( qCII_HMHDPlatformLoc ) )
							{
								if ( qCII_UpgradeIcelands.GetStatus() == OBJECTIVE_UNAVAILABLE )
								{
									SetCurrentObjective( qCII_HMHD );
									SetCurrentObjectiveShiplog( qCII_HMHD );
								}
								else
								{
									if ( qCII_UpgradeIcelands.GetStatus() == OBJECTIVE_PENDING )
									{
										SetCurrentObjective( qCII_UpgradeIcelands );
										SetCurrentObjectiveShiplog( qCII_UpgradeIcelands );
									}
									else
									{
										SetCurrentObjective( qCII_HMHDMissileLoc );
										SetCurrentObjectiveShiplog( qCII_HMHDMissileLoc );
									}
								}
							}
							else
							{
								SetCurrentObjective( qCII_HMHDPlatformLoc );
								SetCurrentObjectiveShiplog( qCII_HMHDPlatformLoc );
							}
						}
						else
						{
							SetCurrentObjective( qCII_HMHD );
							SetCurrentObjectiveShiplog( qCII_HMHD );
						}
					}
				}
				else
				{
					SetCurrentObjective( q_Chapter2 );
					SetCurrentObjectiveShiplog( q_Chapter2 );
				}
			}
		}

		//--------------------------------------------------
		//Setting Current Task For ChapterIII
		if ( q_Chapter3.GetStatus() == OBJECTIVE_PENDING )
		{
			SetCurrentObjective( qCIII_GetShin );
			if ( qCIII_UpgradeMarshes.GetStatus() == OBJECTIVE_PENDING )
			{
				SetCurrentObjective( qCIII_UpgradeMarshes );
				SetCurrentObjectiveShiplog( qCIII_UpgradeMarshes );
				return;
			}

			if ( dlg_CTSV_chapIII_TorpedoInfo2.IsFinished() )
			{
				SetCurrentObjective( qCIII_TorpedoRocket );
				SetCurrentObjectiveShiplog( qCIII_TorpedoRocket );
			}

			if ( IsObjectiveCompleted( qCIII_TorpedoRocket ) )
			{
				SetCurrentObjective( qCIII_ThermopylaeConq1st );
				SetCurrentObjectiveShiplog( qCIII_ThermopylaeConq1st );
			}

			if ( qCIII_ShieldThermopylae.GetStatus() == OBJECTIVE_PENDING )
			{
				SetCurrentObjective( qCIII_ShieldThermopylae );
				SetCurrentObjectiveShiplog( qCIII_ShieldThermopylae );
			}

			if ( IsObjectiveCompleted( qCIII_ShieldThermopylae) )
			{
				SetCurrentObjective( qCIII_ThermopylaeConq1st );
				SetCurrentObjectiveShiplog( qCIII_ThermopylaeConq1st );
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void RC_Finished( string islandName )
	{
		if ( RC_FinishedCnt == 0 )
		{
			if ( !CheatStart )
				dlg_CTSV_chapII_SpecialBlueprint.ToQueue();

			q_SpecialBlueprint.SetStatus( OBJECTIVE_PENDING );
		}

		if ( GetIslandArrayPosition( CII_BlueprintsIslands, islandName ) >= 0 )
		{
			if ( islandName != CII_HMHDMissileLoc && islandName != CII_HMHDPlatformLoc &&  islandName != CII_WalrusTurboLoc && islandName != CII_MantaForsageLoc && islandName != "Endymion" )
			{
				if ( !CheatStart )
				{
					EnableProductionEx( PlayerUEC, CII_BlueprintsGroupI[ RC_FinishedCntGroupI ] );
	
					switch( CII_BlueprintsGroupI[ RC_FinishedCntGroupI]  )
					{
						case armorWalrusMedium:
							dlg_adv_armorI_walrus_desc.ToQueue();
							break;
	
						case armorWalrusHeavy:
							dlg_adv_armorII_walrus_desc.ToQueue();				
							break;
	
						case armorMantaMedium:
							dlg_adv_armorI_manta_desc.ToQueue();
							break;
	
						case armorMantaHeavy:
							dlg_adv_armorII_manta_desc.ToQueue();
							break;
	
						case wWalrusMachineGun:
							dlg_adv_blueprint_mg.ToQueue();
							break;
	
						case wWalrusLaser :
							dlg_adv_blueprint_laser.ToQueue();
							break;
	
						case wWalrusGatling :
							dlg_adv_blueprint_gatling.ToQueue();
							break;
	
						case wWalrusGrenade :
							dlg_adv_blueprint_grenade.ToQueue();
							break;
	
						case wWalrusShell :
							dlg_adv_blueprint_shell.ToQueue();
							break;

						case wWalrusHeat :
							dlg_adv_blueprint_heat.ToQueue();				
							break;

						case wWalrusPlasma :
							dlg_adv_blueprint_plasma.ToQueue();
							break;

						case wWalrusAA:
							dlg_adv_blueprint_aa.ToQueue();
							break;

						case wWalrusFlak:
							dlg_adv_blueprint_flak.ToQueue();
							break;
		
/*
						case wWalrusLauncher:
							dlg_adv_weapon_desc_launcher.ToQueue();
							break;
*/
						case wWalrusHowitzer:
							dlg_adv_blueprint_howitzer.ToQueue();
							break;

						case wWalrusRepairGun:
							dlg_adv_blueprint_repair.ToQueue();
							break;
					}
				}
				else
					PlayerUEC.GetProduction().Enable(CII_BlueprintsGroupI[ RC_FinishedCntGroupI ]);
	
				RC_FinishedCntGroupI += 1;
			}

			if ( CII_WalrusTurboLoc == islandName && qCII_UpgradeTurbo.GetStatus() != OBJECTIVE_COMPLETE )
				ForceObjectiveComplete( qCII_UpgradeTurbo );
	
			if ( CII_MantaForsageLoc == islandName && qCII_UpgradeForsage.GetStatus() != OBJECTIVE_COMPLETE )
				ForceObjectiveComplete( qCII_UpgradeForsage );
	
			switch( islandName )
			{
			case "Bacchus":
				CampaignLog("[CC:GM] >>> RC Finished on Bacchus." , 6);
				qCII_Bacchus_RC.SetStatus( OBJECTIVE_COMPLETE );
				RC_Finished_Bacchus = true;
	
				if ( CII_HMHDPlatformLoc == islandName )
					qCII_HMHDPlatformLoc.SetStatus( OBJECTIVE_COMPLETE );
				else
					CTSV_chapII_HMHDNotFound();
				break;
	
			case "Taksaven":
				CampaignLog("[CC:GM] >>> RC Finished on Taksaven." , 6);
				qCII_Taksaven_RC.SetStatus( OBJECTIVE_COMPLETE );
				RC_Finished_Taksaven = true;
				if ( CII_HMHDPlatformLoc == islandName )
					qCII_HMHDPlatformLoc.SetStatus( OBJECTIVE_COMPLETE );
				else
					CTSV_chapII_HMHDNotFound();
				break;
	
			case "Isolus":
				CampaignLog("[CC:GM] >>> RC Finished on Isolus." , 6);
				qCII_Isolus_RC.SetStatus( OBJECTIVE_COMPLETE );
				RC_Finished_Isolus = true;
	
				if ( CII_HMHDMissileLoc == islandName )
					qCII_HMHDMissileLoc.SetStatus( OBJECTIVE_COMPLETE );
				else
				{
					EnableProductionEx( PlayerUEC, CII_BlueprintsGroupII[ CII_BlueprintsGroupIICnt ] );
	
					if ( qCII_HMHDMissileLoc.GetStatus() != OBJECTIVE_COMPLETE  && !CheatStart )
						CTSV_chapII_HMHDNotFound();
	
					if ( CII_BlueprintsGroupII[ CII_BlueprintsGroupIICnt ] == armorMantaMedium )
						CTSV_chapII_MantaMediumArmorFound();
	
					CII_BlueprintsGroupIICnt += 1;
				}
				break;
	
			case "Lingard":
				CampaignLog("[CC:GM] >>> RC Finished on Lingard." , 6);
				qCII_Lingard_RC.SetStatus( OBJECTIVE_COMPLETE );
				RC_Finished_Lingard = true;
	
				if ( CII_HMHDMissileLoc == islandName )
					qCII_HMHDMissileLoc.SetStatus( OBJECTIVE_COMPLETE );
				else
				{
					EnableProductionEx( PlayerUEC, CII_BlueprintsGroupII[ CII_BlueprintsGroupIICnt ] );
	
					if ( qCII_HMHDMissileLoc.GetStatus() != OBJECTIVE_COMPLETE && !CheatStart )
						CTSV_chapII_HMHDNotFound();
	
					if ( CII_BlueprintsGroupII[ CII_BlueprintsGroupIICnt ] == armorMantaMedium )
						CTSV_chapII_MantaMediumArmorFound();
	
					CII_BlueprintsGroupIICnt += 1;
				}
				break;
	
			case "Vattland":
				CampaignLog("[CC:GM] >>> RC Finished on Vattland." , 6);
				qCII_Vattland_RC.SetStatus( OBJECTIVE_COMPLETE );
				RC_Finished_Vattland = true;
	
				if ( CII_HMHDMissileLoc == islandName )
					qCII_HMHDMissileLoc.SetStatus( OBJECTIVE_COMPLETE );
				else
				{
					EnableProductionEx( PlayerUEC, CII_BlueprintsGroupII[ CII_BlueprintsGroupIICnt ] );
	
					if ( qCII_HMHDMissileLoc.GetStatus() != OBJECTIVE_COMPLETE && !CheatStart )
						CTSV_chapII_HMHDNotFound();
	
					if ( CII_BlueprintsGroupII[ CII_BlueprintsGroupIICnt ] == armorMantaMedium )
						CTSV_chapII_MantaMediumArmorFound();
	
					CII_BlueprintsGroupIICnt += 1;
				}
				break;
	
			case "Evergreen":
				CampaignLog("[CC:GM] >>> RC Finished on Evergreen." , 6);
				qCII_Evergreen_RC.SetStatus( OBJECTIVE_COMPLETE );
				PlayerUEC.GetCarrier().AddEquipment( wCarrierRearRightGatling );
				g_Game.AddMessage("#item_was_added_carrier", COLOR_YELLOW, LMF_EMPIRE, g_Game.ArticleName( wCarrierRearRightGatling ) );
				break;
	
			case "Nemesis":
				CampaignLog("[CC:GM] >>> RC Finished on Nemesis." , 6);
				qCII_Nemesis_RC.SetStatus( OBJECTIVE_COMPLETE );
				break;
	
			case "Beacon":
				CampaignLog("[CC:GM] >>> RC Finished on Beacon." , 6);
				qCII_Beacon_RC.SetStatus( OBJECTIVE_COMPLETE );
				break;
	
			case "Granite":
				CampaignLog("[CC:GM] >>> RC Finished on Granite." , 6);
				qCII_Granite_RC.SetStatus( OBJECTIVE_COMPLETE );
				PlayerUEC.GetCarrier().AddEquipment( wCarrierRearLeftGatling );
				g_Game.AddMessage("#item_was_added_carrier", COLOR_YELLOW, LMF_EMPIRE, g_Game.ArticleName( wCarrierRearLeftGatling ) );
				break;
	
			case "Endymion":
				CampaignLog("[CC:GM] >>> RC Finished on Endymion." , 6);
				qCII_Endymion_RC.SetStatus( OBJECTIVE_COMPLETE );
				CTSV_UpgradeForIcelands();
				break;
	
			}
		}

		if ( q_Chapter3.GetStatus() == OBJECTIVE_PENDING )
		{
			// check jestli to je ostrov ze tretiho chapteru
			if ( GetIslandArrayPosition( CIII_BlueprintsIslands, islandName ) >= 0 )
			{
				for( int i = 0; i < sizeof( CIII_BlueprintsIslands ); i++ )
				{
					string island = CIII_BlueprintsIslands[i];
					if ( islandName != island)
						continue;
					else
					{
						int item = CIII_BlueprintsGroup[i];
						if ( item == -1 )
						{
							//Tenhle blueprint uz bohuzel mame, takze cesta sem byla zbytecna
							dlg_adv_blueprint_notfound_essi_01.ToQueue();
							return;
						}


						EnableProductionEx( PlayerUEC, item );

						if ( item == upgradeComputer )
							ProductionUEC.Enable( upgradeComputerManta );

						if ( item == wWalrusPlasma )
							ProductionUEC.Enable( wMantaPlasmas );

						if ( item == wMantaMissile )
						{
							EnableProductionEx( PlayerUEC, wMantaTomahawk );					
							EnableProductionEx( PlayerUEC, wWalrusLauncher );
						}

						RC_FinishedCntGroupIII += 1;
						if ( RC_FinishedCntGroupIII >= 4 )
							g_Achievements.OnAllBlueprints();
						break;
					}
				}	
			}
		}

		RC_ACTIVATED[RC_FinishedCnt] = islandName;
		RC_FinishedCnt +=1;
		SetCurrentTask( islandName );
	}

	//-----------------------------------------------------------------------------------------------------------------
	void RC_ActivatorUsed( Activator activator, string islandName )
	{
		//Get Command Center player
		if ( g_Game.GetCommandCenter() != NULL && g_Game.GetCommandCenter().GetPlayer() == PlayerUEC )
		{
			activator.DisableUse();
			activator.EnableCammoRemap();
			RC_Finished( islandName );
		}
		else
		{
			CTSV_chapII_ResearchCentre_noCode();
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CCGMBuildingHacked( int bType, bool chooseNew )
	{
		int item = -1;

		//Chapter II random groups
		//------------------------------------------------------------------------------
		if ( q_Chapter1.GetStatus() == OBJECTIVE_COMPLETE && q_Chapter2.GetStatus() != OBJECTIVE_COMPLETE )
		{
			if ( chooseNew )
			{
				if ( bType == BuildingFactory )
				{
					item = PrepareRandomItem( CII_ItemsGroupFactory );
					AddRandomItem( item  );
				}

				if ( bType == BuildingRefinery )
				{
					item = PrepareRandomItem( CII_ItemsGroupRafinery );
					AddRandomItem( item );
				}

				if ( bType == BuildingHeadQuarters )
				{
					item = PrepareRandomItem( CII_ItemsGroupDefense );
					AddRandomItem( item );
				}
			}
			else
			{
				AddRandomItem( RandomItem );
			}
		}

		//Chapter III random groups
		//------------------------------------------------------------------------------
		if ( q_Chapter2.GetStatus() == OBJECTIVE_COMPLETE && q_Chapter3.GetStatus() != OBJECTIVE_COMPLETE )
		{
			if ( chooseNew )
			{
				if (bType == BuildingFactory )
				{
					item = PrepareRandomItem( CIII_ItemsGroupFactory );
					AddRandomItem( item );
				}

				if ( bType == BuildingRefinery )
				{
					item = PrepareRandomItem( CIII_ItemsGroupRafinery );
					AddRandomItem( item );
				}

				if ( bType == BuildingHeadQuarters )
				{
					item = PrepareRandomItem( CIII_ItemsGroupDefense );
					AddRandomItem( item );
				}
			}
			else
			{
				AddRandomItem( RandomItem );
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CompleteChapter1()
	{
		g_Game.FindIslandByName( "Vulcan" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Arachnid" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Treasure" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Frontier" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Outpost" ).AssignToPlayer( PlayerUEC, true );
		q_Chapter1.SetStatusRecursive( OBJECTIVE_PENDING );
		q_Chapter1.SetStatusRecursive( OBJECTIVE_COMPLETE );
		q_Vulcan.SetStatus( OBJECTIVE_COMPLETE );
		q_Arachnid.SetStatus( OBJECTIVE_COMPLETE );
		q_Treasure.SetStatus( OBJECTIVE_COMPLETE );
		q_Frontier.SetStatus( OBJECTIVE_COMPLETE );
		q_Outpost.SetStatus( OBJECTIVE_COMPLETE );
		qCII_Nemesis1st.SetStatus( OBJECTIVE_PENDING );
		qCII_Evergreen1st.SetStatus( OBJECTIVE_PENDING );
		qCII_Beacon1st.SetStatus( OBJECTIVE_PENDING );
		qCII_Bacchus1st.SetStatus( OBJECTIVE_PENDING );
		qCII_Endymion1st.SetStatus( OBJECTIVE_PENDING );
		qCII_Granite1st.SetStatus( OBJECTIVE_PENDING );
		qCII_Taksaven1st.SetStatus( OBJECTIVE_PENDING );
		qCII_Vattland1st.SetStatus( OBJECTIVE_PENDING );
		qCII_Lingard1st.SetStatus( OBJECTIVE_PENDING );
		qCII_Isolus1st.SetStatus( OBJECTIVE_PENDING );
		PlayerUEC.EnableCarrierRoaming( true );
		PlayerUEC.EnableCarrierManual( true );	
	}

	//-----------------------------------------------------------------------------------------------------------------
	void CompleteChapter2()
	{
		CompleteChapter1();

		g_Game.FindIslandByName( "Nemesis" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Evergreen" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Beacon" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Bacchus" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Endymion" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Taksaven" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Granite" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Vattland" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Lingard" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Isolus" ).AssignToPlayer( PlayerUEC, true );
		g_Game.FindIslandByName( "Fulcrum" ).AssignToPlayer( PlayerUEC, true );

		q_SpecialBlueprint.SetStatusRecursive( OBJECTIVE_PENDING  );
		q_SpecialBlueprint.SetStatusRecursive( OBJECTIVE_COMPLETE  );
		g_Game.ForceObjectiveComplete( qCII_UpgradeIcelands );

		q_Chapter2.SetStatusRecursive( OBJECTIVE_PENDING );
		q_Chapter2.SetStatusRecursive( OBJECTIVE_COMPLETE );
		q_DeadZone.SetStatus( OBJECTIVE_PENDING );

		RC_FinishedCnt = 10;

/*
		RC_Finished( "Nemesis" );
		RC_Finished( "Evergreen" );
		RC_Finished( "Beacon" );
		RC_Finished( "Bacchus" );
		RC_Finished( "Endymion" );
		RC_Finished( "Taksaven" );
		RC_Finished( "Granite" );
		RC_Finished( "Vattland" );
		RC_Finished( "Lingard" );
		RC_Finished( "Isolus" );

		CCGMBuildingHacked( BuildingFactory, true );
		CCGMBuildingHacked( BuildingFactory, true );
		CCGMBuildingHacked( BuildingHeadQuarters, true );
		CCGMBuildingHacked( BuildingFactory, true );
		CCGMBuildingHacked( BuildingFactory, true );
		CCGMBuildingHacked( BuildingRefinery, true );
		CCGMBuildingHacked( BuildingHeadQuarters, true );
		CCGMBuildingHacked( BuildingFactory, true );
		CCGMBuildingHacked( BuildingRefinery, true );
		CCGMBuildingHacked( BuildingRefinery, true );
*/
	}

	//!ctor
	void GaeaMission_Campaign()
	{
		CampaignLog( "[CC:GM] >>> Carrier Command: Gaea Mission campaign created.", 8 );
		
		g_Game.SetWorldNameMap("worlds/StrategyWorld.ent");

		PlayerNeutral = NULL;
		PlayerUEC = NULL;
		PlayerAPA = NULL;

		//Tutorial variable pool

		Tut_IslandInfoState = 0;
		Tut_EquipState = 0;

		IslandsUEC = 0;
		IslandsAPA = 0;

		MultiForce = 1.0;
		UnitSkill = 0.5;
		UnitSkillRange = 0.2;

		CurrentIsland = NULL;

		//Missions variable pool
		SkipChapter = false;
		CheatStart = false;
		RC_Finished_Lingard = false; 
		RC_Finished_Vattland = false;
		RC_Finished_Isolus = false;
		RC_Finished_Bacchus = false;
		RC_Finished_Taksaven = false;

		StartChapter_II = false;
		CII_CodeGainedI_Taksaven = false;
		CII_CodeGainedI_Missile = false;
		CII_CodeGainedII = false;
		CII_AuroraBack = false;
		CII_CountDownFinished = false;
		CII_BurnedGround = false;

		CIII_AuroraFound = false;
		CIII_AuroraFoundPart2 = false;
		CIII_Torpedo1stPartGained = false;
		CIII_ShinContact = 0;
		CIII_MyrikHistory2Played = "";

		SelectCarrierAfterLoad = false;

		CII_CountDown = -1;
		CII_CountDownStart = false;

		Tut_IslandInfoEssiState = false;

		RC_FinishedCnt = 0;
		RC_FinishedCntGroupI = 0;
		RC_FinishedCntGroupIII = 0;
		CII_BlueprintsGroupIICnt = 0;
		CurrentChapter = 0;
		IslandsAtFulcrum = 0;
		IslandsAfterFulcrum = -1;
		IslandAurora = 0;
		IslandsMarshes = 0;
		IslandTorpedoInfo = 0;
		CIII_VolcanicShields = 0;

		SpecialBlueprintCnt = 0;
		RandomItem = -1;

		CompleteObjectiveAfterCutscene = false;
		WhichObjectiveToComplete = NULL;
		
		WhichCutsceneToPlay = "No";
		WhichWorldToLoad = "NoWorld";
		CII_HMHDMissileLoc = "";
		CII_HMHDPlatformLoc = "";
		CIII_ShieldLoc1 = "";
		CIII_ShieldLoc2 = "";
		CIII_FirstVolcanicPlayed = "";
		SpecialBlueprintLoc1 = "";
		SpecialBlueprintLoc2 = "";
		SpecialBlueprintLoc3 = "";
		CIII_APACarrierLoc = "";
		EvaluatingCarrierAttack = 1;

		//TEMP:
		SpawnTurret = true;

		int index = 0;
		CII_BlueprintsGroupI[index++] = wWalrusAA;
		CII_BlueprintsGroupI[index++] = armorWalrusMedium;
		CII_BlueprintsGroupI[index++] = wWalrusLaser;
		CII_BlueprintsGroupI[index++] = wWalrusShell;
		CII_BlueprintsGroupI[index++] = wMantaRocket;

		index = 0;
		CII_BlueprintsGroupII[index++] = wMantaLasers;
		CII_BlueprintsGroupII[index++] = armorMantaMedium;

		index = 0;
		CII_ItemsGroupFactory[index++] = bodyManta;
		CII_ItemsGroupFactory[index++] = bodyWalrus;
		CII_ItemsGroupFactory[index++] = armorWalrusMedium;
		CII_ItemsGroupFactory[index++] = armorMantaMedium;
		CII_ItemsGroupFactory[index++] = upgradeAmmoBox;
		CII_ItemsGroupFactory[index++] = upgradeAmmoBoxManta;
		CII_ItemsGroupFactory[index++] = bodyManta;
		CII_ItemsGroupFactory[index++] = bodyWalrus;
		CII_ItemsGroupFactory[index++] = armorWalrusMedium;
		CII_ItemsGroupFactory[index++] = armorMantaMedium;

		index = 0;
		CII_ItemsGroupRafinery[index++] = capsuleDefense;
		CII_ItemsGroupRafinery[index++] = capsuleProduction;
		CII_ItemsGroupRafinery[index++] = capsuleResource;
		CII_ItemsGroupRafinery[index++] = capsuleHack;
		CII_ItemsGroupRafinery[index++] = fCarrierFuel10;
		CII_ItemsGroupRafinery[index++] = capsuleDefense;
		CII_ItemsGroupRafinery[index++] = capsuleProduction;
		CII_ItemsGroupRafinery[index++] = capsuleResource;
		CII_ItemsGroupRafinery[index++] = capsuleHack;
		CII_ItemsGroupRafinery[index++] = fCarrierFuel10;

		index = 0;//TODO: BETTER ITEMS
		CII_ItemsGroupDefense[index++] = wWalrusMachineGun;
		CII_ItemsGroupDefense[index++] = wWalrusLaser;
		CII_ItemsGroupDefense[index++] = wWalrusGrenade;
		CII_ItemsGroupDefense[index++] = wMantaMachineGuns;
		CII_ItemsGroupDefense[index++] = wMantaLasers;
		CII_ItemsGroupDefense[index++] = wWalrusAA;
		CII_ItemsGroupDefense[index++] = wWalrusMachineGun;
		CII_ItemsGroupDefense[index++] = wWalrusLaser;
		CII_ItemsGroupDefense[index++] = wMantaMachineGuns;
		CII_ItemsGroupDefense[index++] = wMantaLasers;

		index = 0;
		CIII_ItemsGroupFactory[index++] = bodyManta;
		CIII_ItemsGroupFactory[index++] = bodyWalrus;
		CIII_ItemsGroupFactory[index++] = armorWalrusHeavy;
		CIII_ItemsGroupFactory[index++] = armorMantaHeavy;
		CIII_ItemsGroupFactory[index++] = armorWalrusMedium;
		CIII_ItemsGroupFactory[index++] = armorMantaMedium;
		CIII_ItemsGroupFactory[index++] = bodyManta;
		CIII_ItemsGroupFactory[index++] = bodyWalrus;
		CIII_ItemsGroupFactory[index++] = armorWalrusHeavy;
		CIII_ItemsGroupFactory[index++] = armorMantaHeavy;

		index = 0;
		CIII_ItemsGroupRafinery[index++] = capsuleDefense;
		CIII_ItemsGroupRafinery[index++] = capsuleProduction;
		CIII_ItemsGroupRafinery[index++] = capsuleResource;
		CIII_ItemsGroupRafinery[index++] = capsuleHack;
		CIII_ItemsGroupRafinery[index++] = fCarrierFuel10;
		CIII_ItemsGroupRafinery[index++] = capsuleDefense;
		CIII_ItemsGroupRafinery[index++] = capsuleProduction;
		CIII_ItemsGroupRafinery[index++] = capsuleResource;
		CIII_ItemsGroupRafinery[index++] = capsuleHack;
		CIII_ItemsGroupRafinery[index++] = fCarrierFuel10;

		index = 0;
		CIII_ItemsGroupDefense[index++] = wWalrusGatling;
		CIII_ItemsGroupDefense[index++] = wWalrusLauncher;
		CIII_ItemsGroupDefense[index++] = wWalrusHeat;
		CIII_ItemsGroupDefense[index++] = wWalrusFlak;
		CIII_ItemsGroupDefense[index++] = wWalrusHowitzer;
		CIII_ItemsGroupDefense[index++] = wMantaMissile;
		CIII_ItemsGroupDefense[index++] = wMantaTomahawk;
		CIII_ItemsGroupDefense[index++] = wWalrusShell;
		CIII_ItemsGroupDefense[index++] = wMantaRocket;
		CIII_ItemsGroupDefense[index++] = wMantaBomb;

		index = 0;
		CIII_BlueprintsGroup[index++] = -1;
		CIII_BlueprintsGroup[index++] = upgradeComputer;//dat je oboje najednou s mantou
		CIII_BlueprintsGroup[index++] = -1;
		CIII_BlueprintsGroup[index++] = wWalrusPlasma;//dat stimhle i plasmu na mantu
		CIII_BlueprintsGroup[index++] = -1;
		CIII_BlueprintsGroup[index++] = wMantaMissile; //da stimhle i tomahawk a walrus launcher
		CIII_BlueprintsGroup[index++] = wWalrusHowitzer;

		index = 0;
		CII_BlueprintsIslands[index++] = "Nemesis";
		CII_BlueprintsIslands[index++] = "Evergreen";
		CII_BlueprintsIslands[index++] = "Beacon";
		CII_BlueprintsIslands[index++] = "Bacchus";
		CII_BlueprintsIslands[index++] = "Endymion";
		CII_BlueprintsIslands[index++] = "Taksaven";
		CII_BlueprintsIslands[index++] = "Granite";
		CII_BlueprintsIslands[index++] = "Vattland";
		CII_BlueprintsIslands[index++] = "Lingard";
		CII_BlueprintsIslands[index++] = "Isolus";

		index = 0;
		CIII_BlueprintsIslands[index++] = "Genetix";
		CIII_BlueprintsIslands[index++] = "Milestone";
		CIII_BlueprintsIslands[index++] = "Duessa";
		CIII_BlueprintsIslands[index++] = "Terminus";
		CIII_BlueprintsIslands[index++] = "Medusa";
		CIII_BlueprintsIslands[index++] = "Sanctuary";
		CIII_BlueprintsIslands[index++] = "Somnus";
	}

	//!dtor
	void ~GaeaMission_Campaign()
	{
		g_Game.SetTutorialHighlight(TH_HIGHLIGHT_NONE);
	}

	//! Set global pointers for production (after load)
	void GainProduction()
	{
		PlayerUEC = g_Game.GetPlayer(1);
		PlayerAPA = g_Game.GetPlayer(2);
	
		ProductionUEC = PlayerUEC.GetProduction();
		ProductionAPA = PlayerAPA.GetProduction();
		CarrierStockUEC = PlayerUEC.GetCarrierStorage();
		CarrierStockAPA = PlayerAPA.GetCarrierStorage();
		StockPileUEC = PlayerUEC.GetStockpileStorage();
		StockPileAPA = PlayerAPA.GetStockpileStorage();		
	}

	/** \name Function called from C++ side ( it's better to take them like Events ) */
	//@{

	//! Create players
	bool OnCreatePlayers()
	{
		CGame game = GetGame();
		if( !game )
			return false; // no game to enter, dude!

		// Neutral player already exist - just read!
		PlayerNeutral = game.GetPlayer( 0 );

		//! DO NOT CHANGE ORDER, OR ELSE EVERYTHING WILL SCREW UP!
		PlayerUEC = game.CreateNewPlayer( "UEC" );
		PlayerUEC.SetColors( 0xff00aeff, /* 0xfff6a80e */ 0xffffffff,/* 0xff4aaafc */ 0xffffffff );

		PlayerAPA = game.CreateNewPlayer( "APA" );
		PlayerAPA.SetColors( 0xffff0000, 0xffe30107, 0xffbc0207);
		//! DO NOT CHANGE ORDER, OR ELSE EVERYTHING WILL SCREW UP!

		game.SetControlledPlayer( PlayerUEC.GetID() /* 1 */ );

		//! Set global pointers for production
		GainProduction();

		CampaignLog( "[CC:GM] >>> OnCreatePlayers() - Distributing islands among players...", 7 );

		//TEMP: setup island owners here
		//all islands is captured by enemy now
		int allIslands = g_Game.GetNumIslands();
		for ( int i = 0; i < allIslands; i++ )
		{
			IslandModel island = g_Game.GetIsland(i);
			if ( island.IsEnabledInGame() )
			{
				island.AssignToPlayer( PlayerAPA, false );
				IslandsAPA += 1;
				ActiveSlots[i] = island.GetName();
			}
		}

#ifdef DEVELOPER
		PlayerUEC.EnableIslandUnitControl(true);
#endif

		return true;
	}

	//! Create strategic
	bool OnCreateStrategic()
	{
      	// set enemy stockpile
		PlayerAPA.SetStockpile( g_Game.FindIslandByName( "Fulcrum" ) );

	    return true;
	}

	//! Entering campaign island paramter works for command line parameter handling 
	//See more in GM_EnterCampaign.h
	bool OnEnterCampaign( IslandModel pIsland );

	//! Called before campaign world load, handle entity spawning here
	//! For more see - GM_BeforeIslandLoad.h file
	void OnBeforeWorldLoad( IslandModel pIsland );

	//! Called during campaign world load, handle entity spawning here
	//! For more see - GM_BeforeIslandLoad.h file
	void OnProcessWorldLoad( IslandModel pIsland );

	//! Called after all entities and textures loaded
	//! For more see - GM_AfterWorldLoad.h file
	int OnAfterWorldLoad( IslandModel pIsland );

	//! Called when player travels to another island
	int OnBeforeCarrierToIsland( IslandModel pIsland )
	{
		if ( q_Chapter1.GetStatus() == OBJECTIVE_PENDING )
		{
			string islandName = g_Game.GetCurrentIsland().GetName();
			if ( islandName == "Vulcan" && pIsland.GetName() == "Vulcan")
				return 0;

			if ( islandName == "Arachnid" )
			{
				if ( pIsland.GetName() == "Vulcan" || pIsland.GetName() == "Arachnid" )
				{
					dlg_adv_islandalreadycatptured_okoro_01.ToQueue();
					return 0;
				}
			}

			if ( islandName == "Arachnid" && pIsland.GetName() == "Treasure")
			{
				if ( IsAllAliveUnitsDocked() )
					return 1;
				else
				{
					g_Game.ShowHint("#dockunitsbeforetimewarp", 12, false);
					return 0;
				}
			}

			if ( islandName == "Treasure" )
			{
				if ( pIsland.GetName() == "Vulcan" || pIsland.GetName() == "Arachnid" )
				{
					dlg_adv_islandalreadycatptured_okoro_01.ToQueue();
					return 0;
				}

				if ( pIsland.GetName() == "Treasure" )
				{
					if ( pIsland.GetPlayer() == PlayerUEC )
					{
						dlg_adv_islandalreadycatptured_okoro_01.ToQueue();
						return 0;
					}
					else
					{
						return 0;
					}
					
				}

				if ( islandName == "Treasure" && pIsland.GetName() == "Frontier")
				{
					if ( IsAllAliveUnitsDocked() )
						return 1;
					else
					{
						g_Game.ShowHint("#dockunitsbeforetimewarp", 12, false);
						return 0;
					}
				}
			}

			if ( islandName == "Frontier" )
			{
				if ( pIsland.GetName() == "Vulcan" || pIsland.GetName() == "Arachnid" || pIsland.GetName() == "Treasure" || pIsland.GetName() == "Frontier" )
				{
					dlg_adv_islandalreadycatptured_okoro_01.ToQueue();
					return 0;
				}

				if ( islandName == "Frontier" && pIsland.GetName() == "Outpost")
				{
					if ( IsAllAliveUnitsDocked() )
						return 1;
					else
					{
						g_Game.ShowHint("#dockunitsbeforetimewarp", 12, false);
						return 0;
					}
				}
			}
		}
		return 1;
	}

	//! Action from action queue was started
	void OnQueueActionStarted(QueueAction action)
	{
		//After Vulcan is finished
		//---------------------------------------------------------
		if ( action == dlg_adv_Com_UnitsAndLayout )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_COMMAND_BAR );

		if ( action == hint_tut_hinthistory )
		{
			g_Game.EnableStatsScreen( true );
			g_Game.GetControlledPlayer().GetCarrier().SelectForPlayer();
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_SHIPLOG );
		}
//<---- Vulcan

		//Prejezd Vulcan -> Arachnid
		//---------------------------------------------------------
		if ( action == dlg_adv_Com_UnitsAndLayout2 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_COMMAND_BAR_UNIT1 );

		//---------------------------------------------------------
		if ( action == dlg_adv_Com_UnitsAndLayout3 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_COMMAND_BAR_UNIT6 );

		//---------------------------------------------------------
		if ( action == dlg_adv_Com_UnitsAndLayout4 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_COMMAND_BAR_WALRUS_SLOT1 );

		//---------------------------------------------------------
		if ( action == dlg_adv_Com_UnitsAndLayout5 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_COMMAND_BAR_WALRUS_LEDS );
//<---- Vulcan -> Arachnid


		//Prejezd Arachnid -> Treasure
		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_Info_Essi_01 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_ISLINFOSCR_CLIMATE );

		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_Info_Essi_02 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_ISLINFOSCR_SURFACE );

		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_Info_Essi_03 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_ISLINFOSCR_PRODUCTION );

		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_Info_Essi_04 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_ISLINFOSCR_RESOURCES );

		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_Info_Essi_05 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_ISLINFOSCR_DEFENSE );

		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_Info_Essi_06 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_ISLINFOSCR_OBJECTIVES );
//<---- Arachnid -> Treasure


		// Prejezd Treasure -> Frontier
		//---------------------------------------------------------
		if ( action == dlg_rep_adv_description_anderson_02 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_REPSCR_ZONENAME );

		if ( action == dlg_rep_adv_description_anderson_02b )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_REPSCR_PRIORITY );

		if ( action == dlg_rep_adv_description_anderson_02c )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_REPSCR_ENERGYNEEDED );

		if ( action == dlg_rep_adv_description_anderson_02d )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_REPSCR_DAMAGELEVEL );

		//----
		if ( action == dlg_rep_adv_fuelconsumption_anderson_01 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_REPSCR_CARRIERFUEL );

		if ( action == dlg_rep_adv_fuelconsumption_anderson_02 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );

		if ( action == dlg_rep_repairzonepriority_okoro )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_REPSCR_PRIORITY );
//<---- Treasure -> Frontier


		//Prejezd Frontier -> Outpost
		//---------------------------------------------------------
		if ( action == dlg_prs_adv_ProductionDescription_Anderson02 )
		{
		g_Game.SetTutorialHighlight( TH_HIGHLIGHT_PRODSCR_RIGHTSIDE );
			if ( PlayerUEC.GetStockpile() == NULL )
				PlayerUEC.SetStockpile( g_Game.FindIslandByName("Arachnid") );	
		}

		if ( action == dlg_prs_ProductionDescription_01 )
			{
			dicarruec.SelectForPlayer();
			diadvprod = false;
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_PRODSCR_OPENSCREEN );
			}

		if ( action == dlg_prs_adv_ProductionDescription_Anderson02b )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_PRODSCR_LEFTSIDE );

		if ( action == dlg_prs_adv_ProductionDescription_Anderson03a )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_PRODSCR_TIME );

		if ( action == dlg_prs_adv_ProductionDescription_Anderson03b )
			g_Game.SetTutorialHighlight(TH_HIGHLIGHT_PRODSCR_MATERIALS  );

		if ( action == dlg_prs_adv_ProductionDescription_Anderson04 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_PRODSCR_ONCARRIER );

		if ( action == dlg_prs_adv_ProductionDescription_Anderson05 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_PRODSCR_QUEUE );
//<---- Frontier -> Outpost


		//---------------------------------------------------------
		if ( action == dlg_eqp_adv_slots_okoro_02d )
		{
			g_ActionQueue.RemoveAction( dlg_eqp_adv_slots_okoro_02b );
			g_ActionQueue.RemoveAction( dlg_eqp_adv_slots_okoro_02c );
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_EQPSCR_SLOTS );
		}
		if ( action == dlg_eqp_adv_slots_okoro_02 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_EQPSCR_ITEMS )

		if ( action == dlg_eqp_adv_slots_okoro_02c )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_EQPSCR_DESCR )

		//---------------------------------------------------------
		if ( action == dlg_adv_manualcarrierrepaired_anderson )
		{
			PlayerUEC.EnableCarrierRoaming( true );
			PlayerUEC.EnableCarrierManual( true );
		}

		if ( action == dlg_sps_adv_SuppliesScreen_Anderson02 )
			{
			dlg_sps_adv_SuppliesScreen_Anderson02.Interrupt();
			dlg_sps_adv_SuppliesScreen_Anderson02b = CreateDialogAction( CGO_OWNER_CAMPAIGN, NORMAL_PRIORITY, 100, -1);
			dlg_sps_adv_SuppliesScreen_Anderson02b.AddSentenceAction( "#sps_adv_SuppliesScreen_anderson02", 100.0, "AdvisorAnderson" );
			dlg_sps_adv_SuppliesScreen_Anderson03 = CreateDialogAction( CGO_OWNER_CAMPAIGN, NORMAL_PRIORITY, 0, -1);
			dlg_sps_adv_SuppliesScreen_Anderson03.AddSentenceAction( "#sps_adv_SuppliesScreen_anderson03", 100.0, "AdvisorAnderson" );
			dlg_sps_adv_SuppliesScreen_Anderson04 = CreateDialogAction( CGO_OWNER_CAMPAIGN, NORMAL_PRIORITY, 0, -1);
			dlg_sps_adv_SuppliesScreen_Anderson04.AddSentenceAction( "#sps_adv_SuppliesScreen_anderson04", 100.0, "AdvisorAnderson" );
			dlg_sps_adv_SuppliesScreen_Anderson02b.ToQueue();
			Tut_Sps_adv_SuppliesScreen_Anderson = false;
			}
		if ( action == dlg_sps_adv_SuppliesScreen_Anderson02b )
			{
			if ( dicurrentwindow == 2 )
				g_Game.SetTutorialHighlight( TH_HIGHLIGHT_SUPPSCR_LEFTSIDE );
			else
				dlg_sps_adv_SuppliesScreen_Anderson02b.Interrupt();
			}
		if ( action == dlg_sps_adv_SuppliesScreen_Anderson03 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_SUPPSCR_LOAD );

		if ( action == dlg_sps_adv_SuppliesScreen_Anderson04 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_SUPPSCR_SEND );

		if ( action == dlg_sps_adv_SuppliesScreen_Anderson05 )
			{
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_SUPPSCR_ETA1 );
			dlg_sps_adv_SuppliesScreen_Anderson06.ToQueue();
			}

		if ( action == dlg_sps_adv_SuppliesScreen_Anderson06 )
			{
			dlg_sps_adv_SuppliesScreen_Anderson06.Interrupt();
			dlg_sps_adv_SuppliesScreen_Anderson06b = CreateDialogAction( CGO_OWNER_CAMPAIGN, NORMAL_PRIORITY, 100, -1);
			dlg_sps_adv_SuppliesScreen_Anderson06b.AddSentenceAction( "#sps_adv_SuppliesScreen_anderson06", 100.0, "AdvisorAnderson" );
			dlg_sps_adv_SuppliesScreen_Anderson06b.ToQueue();
			}

	}

	//! Action from action queue was finished
	void OnQueueActionFinished(QueueAction action)
	{
		//CampaignLog( "[CC:GM] >>> OnQueueActionFinished.", 3 );
		//---------------------------------------------------------

		//Prejezd Vulcan -> Arachnid (konecna)
		//---------------------------------------------------------
		//---------------------------------------------------------
		if ( action == dlg_adv_Com_UnitsAndLayout5 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );

		if ( action == hint_tut_hinthistory )
		{
			g_ActionQueue.AddWaitAction( VectorLength(dicarruec.GetStrategyPos() - g_Game.GetIsland(30).GetStrategyPos() ) * 2 - 1200 );
			dlg_Gen_adv_AIonIslands_Essi.ToQueue();
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );
		}
		//<-------

		//povoleni equipu na Treasure
		if ( action == dlg_eqp_adv_slots_okoro_01 )
			g_Game.EnableEquipScreen( true );

		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_Info_Essi_06 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );

		//Prejezd Frontier -> Outpost
		//---------------------------------------------------------
		if ( action == dlg_prs_adv_ProductionDescription_Anderson01 )
		{
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_PRODSCR_RIGHTSIDE );
			g_Game.EnableIslandPropertiesTab( true );
			ProductionUEC.EnableWork( true );
			ProductionUEC.EnableSupplies( true );
			PlayerUEC.SpawnBarque();
			PlayerUEC.SetStockpile( g_Game.FindIslandByName("Arachnid") );
			ProductionUEC.Enable( bodyWalrus );
			ProductionUEC.Enable( wWalrusMachineGun );
		}
		if ( action == dlg_prs_adv_ProductionDescription_Anderson05 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );

		//---------------------------------------------------------
		if ( action == dlg_prs_adv_Stockpile_Anderson )
		{
			ProductionUEC.EnableSupplies( true );
			if ( g_Game.FindIslandByName( "Frontier" ).GetPlayer() == PlayerUEC )
				PlayerUEC.SetStockpile( g_Game.FindIslandByName( "Frontier" ) );
			else
				PlayerUEC.SetStockpile( g_Game.FindIslandByName( "Treasure" ) );							

			dlg_sps_SuppliesScreen_Anderson01.ToQueue();
		}

		//---------------------------------------------------------
		if ( action == dlg_sps_adv_SuppliesScreen_Anderson02b && dicurrentwindow == 2 )
			dlg_sps_adv_SuppliesScreen_Anderson03.ToQueue();
		if ( action == dlg_sps_adv_SuppliesScreen_Anderson03 && dicurrentwindow == 2 )
			dlg_sps_adv_SuppliesScreen_Anderson04.ToQueue();
		if ( action == dlg_sps_adv_SuppliesScreen_Anderson04 )
			{
			Tut_Sps_adv_SuppliesScreen_Anderson = true;
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );
			}

		if ( action == dlg_sps_adv_SuppliesScreen_Anderson06 )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );

		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_IslandInfo_Anderson_02 )
		{
			Tut_IslandInfoState += 1;
			if ( Tut_IslandInfoPlay )
				dlg_Iis_adv_IslandInfo_Anderson_03.ToQueue();
		}

		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_IslandInfo_Anderson_03 )
		{
			Tut_IslandInfoState += 1;
			if ( Tut_IslandInfoPlay )
				dlg_Iis_adv_IslandInfo_Anderson_05.ToQueue();
		}
/*
		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_IslandInfo_Anderson_04a )
		{
			Tut_IslandInfoState += 1;
			if ( Tut_IslandInfoPlay )
				dlg_Iis_adv_IslandInfo_Anderson_04b.ToQueue();
		}

		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_IslandInfo_Anderson_04b )
		{
			Tut_IslandInfoState += 1;
			if ( Tut_IslandInfoPlay )
				dlg_Iis_adv_IslandInfo_Anderson_04c.ToQueue();
		}

		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_IslandInfo_Anderson_04c )
		{
			Tut_IslandInfoState += 1;
			if ( Tut_IslandInfoPlay )
				dlg_Iis_adv_IslandInfo_Anderson_05.ToQueue();
		}
*/
		//---------------------------------------------------------
		if ( action == dlg_Iis_adv_IslandInfo_Anderson_05 )
		{
			Tut_IslandInfoState += 1;
			if ( Tut_IslandInfoPlay )
				dlg_Iis_adv_IslandInfo_Anderson_06.ToQueue();
		}

		//---------------------------------------------------------
		//Prejezd Treasure -> Frontier
		if ( action == dlg_rep_adv_nextrepzone_okoro )
		{
			dicarruec.SelectForPlayer();
			g_Game.EnableRepairScreen( true );
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_REPSCR_OPEN );
		}
/*
		//---
		if ( action == dlg_rep_adv_description_anderson_02 )
			dlg_rep_adv_description_anderson_02b.ToQueue();

		if ( action == dlg_rep_adv_description_anderson_02b )
			dlg_rep_adv_description_anderson_02c.ToQueue();

		if ( action == dlg_rep_adv_description_anderson_02c )
			dlg_rep_adv_description_anderson_02d.ToQueue();

		if ( action == dlg_rep_adv_description_anderson_02d )
			dlg_rep_adv_fuelconsumption_anderson_01.ToQueue();

		//----
		if ( action == dlg_rep_adv_fuelconsumption_anderson_01 )
			dlg_rep_adv_fuelconsumption_anderson_02.ToQueue();

		if ( action == dlg_rep_adv_fuelconsumption_anderson_02 )
			dlg_rep_repairzonepriority_okoro.ToQueue();
*/
		if ( action == dlg_rep_repairzonepriority_okoro )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );
		//<------

/*
	bool Tut_Rep_adv_Description_Anderson;
	bool Tut_Rep_adv_FuelConsumption_Anderson;
	bool Tut_Rep_adv_RepairZonePriority_Anderson;
	bool Tut_Rep_adv_RepairZoneChangePriority_Okoro;
	bool Tut_Rep_RepairZonePriority_Okoro;
*/

		if ( action == dlg_whatTodoInChapteriii_myrik )
			g_Game.AutoSave("#fulcrum_save_08");

		//-------------------------OBECNE-------------------------------
		//---------------------------------------------------------
		if ( action == dlg_eqp_adv_slots_okoro_02 )
		{
			if( Tut_EquipPlay )
			{
				dlg_eqp_adv_slots_okoro_02b.ToQueue();
				Tut_EquipState += 1;
			}
		}		
		//---------------------------------------------------------
		if ( action == dlg_eqp_adv_slots_okoro_02b )
		{
			if( Tut_EquipPlay )
			{
				g_Game.SetTutorialHighlight( TH_HIGHLIGHT_EQPSCR_DESCR )
				dlg_eqp_adv_slots_okoro_02c.ToQueue();
				Tut_EquipState += 1;
			}
		}
		//---------------------------------------------------------
		if ( action == dlg_eqp_adv_slots_okoro_02c )
		{
			if( Tut_EquipPlay )
			{
				g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE )
				Tut_EquipState += 1;
			}
		}
		//---------------------------------------------------------
		if ( action == dlg_eqp_adv_slots_okoro_02d )
		{
			Tut_EquipState = 4;
			if( Tut_EquipPlay )
			{
				Tut_Eqp_adv_Slots_Okoro = true;
				g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );
			}
		}

		//---------------------------------------------------------
		if ( action == hint_tut_hinthistory )
			g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );

		//---------------------------------------------------------
		if ( action == dlg_CTSV_noUpgradeForIcelands )
		{
			qCII_UpgradeIcelands.SetStatus( OBJECTIVE_PENDING );
			SetCurrentObjective( qCII_UpgradeIcelands );
			SetCurrentObjectiveShiplog( qCII_UpgradeIcelands );
		}

		//---------------------------------------------------------
		if ( action == dlg_CTSV_chapIII_noUpgradeForMarshes )
		{
			qCIII_UpgradeMarshes.SetStatus( OBJECTIVE_PENDING );
			SetCurrentObjective( qCIII_UpgradeMarshes );
			SetCurrentObjectiveShiplog( qCIII_UpgradeMarshes );
		}

		//---------------------------------------------------------
		if ( action == dlg_CTSV_chapIII_noUpgradeForVolcanic )
			qCIII_UpgradeVolcanic.SetStatus( OBJECTIVE_PENDING );

		//---------------------------------------------------------
		if ( action ==  dlg_CTSV_chapIII_TorpedoInfo2 )
		{
			if ( qCIII_TorpedoRocket.GetStatus() == OBJECTIVE_UNAVAILABLE )
				qCIII_TorpedoRocket.SetStatus( OBJECTIVE_PENDING );
		}

		//---------------------------------------------------------
		if ( action ==  dlg_CTSV_chapIII_TorpedoInfo1 )
			qCIII_DestroyRedDragon.SetStatus( OBJECTIVE_PENDING );

		//---------------------------------------------------------
		if ( action ==  dlg_CTSV_UpgradeForIcelands )
		{
			if ( qCII_UpgradeIcelands.GetStatus() == OBJECTIVE_UNAVAILABLE )
			{
				BanPendingMessage = true;
				qCII_UpgradeIcelands.SetStatus( OBJECTIVE_PENDING );
				BanPendingMessage = false;
			}
	
			if ( qCII_UpgradeIcelands.GetStatus() != OBJECTIVE_COMPLETE )
				qCII_UpgradeIcelands.SetStatus( OBJECTIVE_COMPLETE );
		}

		//---------------------------------------------------------
		if ( action ==  dlg_CTSV_chapIII_TorpedoPart1Found )
		{
			BanPendingMessage = true;
			if ( qCIII_TorpedoRocket.GetStatus() == OBJECTIVE_UNAVAILABLE )
				qCIII_TorpedoRocket.SetStatus( OBJECTIVE_PENDING );
			BanPendingMessage = false;

			qCIII_TorpedoRocket.SetStatus( OBJECTIVE_COMPLETE );

			BanPendingMessage = true;
			if ( qCIII_UpgradeVolcanic.GetStatus() == OBJECTIVE_UNAVAILABLE )
				qCIII_UpgradeVolcanic.SetStatus( OBJECTIVE_PENDING );
			BanPendingMessage = false;

			qCIII_UpgradeVolcanic.SetStatus( OBJECTIVE_COMPLETE );
		}

		//---------------------------------------------------------
		if ( action == dlg_CTSV_chapIII_DisableShieldNeeded )
			SetCurrentTask( g_Game.GetCurrentIsland().GetName() );

		//---------------------------------------------------------
		if ( action ==  dlg_con_adv_GetPlanned_Okoro || action == dlg_con_adv_GetPlanned_Okoro_Joy )
			Tut_Con_GetPlanned = true;

		//---------------------------------------------------------
		if ( action ==  dlg_con_adv_SuspendExec_Okoro )
		{
			if( g_Game.JoypadPreferred() )
				g_Game.ShowHintEx( "#con_getplanned_xbox", "set:ccgui_enforce image:HudUserMarker" );
			else
				g_Game.ShowHintEx( "#con_getplanned", "set:ccgui_enforce image:HudUserMarker" );
		}

		//---------------------------------------------------------
		if ( action ==  dlg_con_adv_LowFuel_Okoro )
			g_Game.ShowHintEx( "#tut_gen_replenisherfuel", "set:ccgui_enforce image:HudFuel" );

		//---------------------------------------------------------
		if ( action ==  dlg_con_adv_LowAmmo_Okoro )
			g_Game.ShowHintEx( "#tut_gen_replenisherammo", "set:ccgui_enforce image:HudAmmo" );

		//---------------------------------------------------------
		//JUST FOR PRESS PREVIEW VERSION
		//MUST BE COMMENTED IN RETAIL VERSION
		//---------------------------------------------------------
//		if ( action ==  dlg_whattodoinchapterii_okoro )
//			g_Game.OnGameOver(300, "#game_previewfinished_action", true);
	}

	//! New entity event
	float OnEntitySpawning( ctype entityClass, string entityName )
	{
		//TEMP: (?)
		CGame game = GetGame();
		CurrentIsland = game.GetCurrentIsland();

		//TEMP: spawn all mantas on non-neutral islands
		if( CurrentIsland.GetPlayer() != PlayerNeutral && entityClass == Type("Manta") ) return 1.0;

		//TEMP: spawn buildings with half health (NOT WORKING!!!)
		if( IsTypeInherited( entityClass, Type("Building") ) ) return 0.5;

		//TEMP: spawn only half turrets
		if( entityClass == Type("Turret") )
		{
			if( SpawnTurret )
			{
				SpawnTurret = false;
				return 1.0;
			}
			else SpawnTurret = true;
		}

		return 0;
	}

	//! On Actor direct death
	void OnActorDeath( InteractiveEntity pActor )
	{
		CampaignLog( "[CC:GM] >>> OnActorDeath - umrel Actor - GameOver.", 3 );
		if ( g_Game.SearchArray( didroid, pActor ) == -1 )
		{
		g_Game.FadeOut(200);
		g_Game.OnGameOver(300, "#gameover_menu_title", false);	//run game over process. call this as last
		}
 	}

	//! On Actor driven unit death
	void OnActorDrivenUnitDeath( InteractiveEntity pDrivenUnit, InteractiveEntity pActor )
	{
		CampaignLog( "[CC:GM] >>> OnActorDrivenUnitDeath - just drop and kill Actor.", 3 );
		g_Game.FadeOut(200);
		g_Game.OnGameOver(300, "#gameover_menu_title", false);	//run game over process. call this as last
	}

	//! Objective added
	void OnObjectiveAdded( Objective obj )
	{
		if ( obj == qCIII_ShieldThermopylae )
		{
			g_Game.FindIslandByName( "Magma" ).EnableOnMap( true );
			g_Game.FindIslandByName( "Obsidian" ).EnableOnMap( true );
			g_Game.FindIslandByName( "Avernus" ).EnableOnMap( true );
			g_Game.FindIslandByName( "Fornax" ).EnableOnMap( true );
		}
		
		if ( obj == qCII_FulcrumConq1st )
		{
			g_Game.FindIslandByName( "Fulcrum" ).EnableOnMap( true );
			if ( g_Game.GetCurrentIsland().GetName() != "Bacchus" || g_Game.GetCurrentIsland().GetName() != "Taksaven" )
				CTSV_chapII_ResearchCodeGained_noHMHD();
		}

		if ( obj == q_Vulcan )
			g_Game.FindIslandByName( "Vulcan" ).EnableOnMap( true );

		if ( obj == q_ArachnidLock )
			g_Game.EnableStatsScreen( true );

		if ( BanGameMessage )
			return;

		if ( q_Vulcan_Explore.GetStatus() == OBJECTIVE_COMPLETE)
			g_Game.PlayGameSound( "ui/NewObjective" );

		if ( obj.IsOptional() )
			g_Game.AddMessage( "#obj_objective_new_optional" , COLOR_YELLOW, LMF_EMPIRE, obj.GetTitle() );
		else
			g_Game.AddMessage( "#obj_objective_new" , COLOR_WHITE, LMF_EMPIRE, obj.GetTitle() );

	}

	//! Mission objective failed
	void OnObjectiveFailed( Objective objective )
	{
		if ( BanGameMessage )
			return;
		g_Game.AddMessage( "#obj_objective_failed" , COLOR_RED , LMF_EMPIRE, objective.GetTitle() );
	}
	
	//! Objective completed
	//! For more see - GM_ObjectiveCompleted.h file
	void OnObjectiveCompleted( local Objective o );


	//! Carrier was destroyed
	void OnCarrierDestroyed( Carrier carrier )
	{
		CCPlayer player = carrier.GetPlayer();
		if ( player == PlayerAPA )
		{
			qCIII_DestroyRedDragon.SetStatus( OBJECTIVE_COMPLETE );
		}

		if ( player == PlayerUEC )
		{
			g_Game.PlayCutsceneOnPos("cutscenes/unitlostCarrier.cut", carrier.GetPosition(), CPM_LOOP, false, false);
			g_Game.OnGameOver(300, "#demo_thermopylae_failCarrier", false);	//run game over process. call this as last
		}
	}

	//! Player just entered timewarp
	bool OnEnterTimeWarp( IslandModel pCurrent, IslandModel pDestination )
	{
		Print( "[CC:GM] >>> OnEnter TimeWarp!!!.");
		string currentName = pCurrent.GetName();
		string destinationName = pDestination.GetName();
		//-------------------------------------------------------------------------------------
		if ( q_Chapter1.GetStatus() == OBJECTIVE_PENDING )
		{
			//--------------------------
			if ( !Tut_Com_UnitsAndLayout )
			{
				if ( currentName == "Vulcan" && destinationName == "Arachnid" )
				{
					g_ActionQueue.Clear();
					if ( dlg_adv_Tutorial_CarrierView_Anderson.IsPlaying() )
						dlg_adv_Tutorial_CarrierView_Anderson.Stop();

					if ( dlg_adv_Tutorial_CarrierView_Anderson_Joy.IsPlaying() )
						dlg_adv_Tutorial_CarrierView_Anderson_Joy.Stop();	
	
					if ( dlg_hint_Tutorial_MapViewIslandZoom.IsPlaying() )
						dlg_hint_Tutorial_MapViewIslandZoom.Stop();

					if ( dlg_hint_Tutorial_MapViewIslandZoom_Joy.IsPlaying() )
						dlg_hint_Tutorial_MapViewIslandZoom_Joy.Stop();

					if ( dlg_adv_Tutorial_Map_TacticAndStrategicZoom.IsPlaying() )
						dlg_adv_Tutorial_Map_TacticAndStrategicZoom.Stop();

					if ( dlg_adv_Tutorial_Map_TacticAndStrategicZoom2.IsPlaying() )
						dlg_adv_Tutorial_Map_TacticAndStrategicZoom2.Stop();

					Tut_Com_UnitsAndLayout = true;
					g_ActionQueue.AddWaitAction( 1300 );
					dlg_adv_Com_UnitsAndLayout.ToQueue();
					dlg_adv_Com_UnitsAndLayout2.ToQueue();
					dlg_adv_Com_UnitsAndLayout3.ToQueue();
					dlg_adv_Com_UnitsAndLayout4.ToQueue();
					dlg_adv_Com_UnitsAndLayout5.ToQueue();
					g_ActionQueue.AddWaitAction( 600 );
					hint_tut_hinthistory.ToQueue(); //na konci pak jeste hint, ze hinty lze nalezt v shiplogu (SHIPLOG button rozblikame)
				}
			}

			//--------------------------
			if ( !dlg_Iis_adv_Info_Essi_00.IsFinished() )
			{
				if ( currentName == "Arachnid" && destinationName == "Treasure" )
					{
					g_ActionQueue.AddWaitAction( 500 );
					dlg_Iis_adv_Info_Essi_00.ToQueue();
					}
			}

			//--------------------------
			if ( !dlg_rep_adv_nextrepzone_okoro.IsFinished() )
			{
				if ( currentName == "Treasure" && destinationName == "Frontier" )
					dlg_rep_adv_nextrepzone_okoro.ToQueue();
			}

			//--------------------------
			if ( !dlg_prs_adv_ProductionDescription_Anderson01.IsFinished() )
			{
				if ( currentName == "Frontier" && pDestination.GetName() == "Outpost" )
				{
					dlg_prs_adv_ProductionDescription_Anderson01.ToQueue();
					dlg_prs_ProductionDescription_01.ToQueue();
				}
			}
		}

		//-------------------------------------------------------------------------------------
		if ( q_Chapter2.GetStatus() == OBJECTIVE_PENDING )
		{
			//--------------------------
			//ShinInfo states
			if ( CII_ShinInfoState == 1  )
			{
				if (  IsObjectiveCompleted( qCII_HMHDPlatformLoc ) || IsObjectiveCompleted( qCII_HMHDMissileLoc ) )
					CTSV_chapII_ShinInfo2();
				else
				{
					if ( IslandsUEC > 8 )
						CTSV_chapII_ShinInfo2();
				}
			}

			//--------------------------
			if ( currentName == "Outpost" && IslandsUEC >= 5 && IslandsUEC < 6)
				CTSV_chapII_Supplybarque();

			//--------------------------
			if ( CII_AuroraBack && CII_ShinInfoState == 0 && IslandsUEC > 6)
				CTSV_chapII_ShinInfo1();

			//--------------------------
			if ( !CII_BurnedGround && IslandsUEC > 5 )
			{
				if ( !dlg_CTSV_chapII_ShinInfo1.InMainQueue() && !dlg_CTSV_chapII_Supplybarque.InMainQueue() )
				{
					if ( !dlg_CTSV_chapII_ShinInfo2_v1.InMainQueue() && !dlg_CTSV_chapII_ShinInfo2_v2.InMainQueue() && !dlg_CTSV_chapII_ShinInfo2_v3.InMainQueue() )
						CTSV_chapII_BurnedGround();
				}
			}

			if ( q_Chapter2.GetStatus() == OBJECTIVE_PENDING )
			{
				if ( qCII_HMHD.GetStatus() != OBJECTIVE_COMPLETE && destinationName == "Fulcrum" )
					dlg_CTSV_warningbeforesail_fulcrum.ToQueue();
			}

			//--------------------------
			if ( !CII_CountDownFinished && CII_CountDownStart )
			{
				if ( g_Game.GetCampaignDays() > CII_CountDown )
					CII_CountDownFinished = true;
			}
		}

		//-------------------------------------------------------------------------------------
		if ( q_Chapter3.GetStatus() == OBJECTIVE_PENDING )
		{
			//--------------------------
			if ( IslandTorpedoInfo == 1 && currentName != "Fulcrum" )
				CTSV_chapIII_TorpedoInfo2();

			//--------------------------
			if ( currentName == "Fulcrum" && IslandTorpedoInfo == 0 )
				CTSV_chapIII_TorpedoInfo1();
		}

		SetCurrentTask( currentName );
		return true;
	}

	//! Player just left timewarp
	bool OnLeaveTimeWarp( IslandModel pCurrent, IslandModel pDestination )
	{
		g_Game.StopMusic( 200 );
		if ( !pDestination )
			pDestination = g_Game.GetIsland(dicurrentisland2);
		string destinationName = pDestination.GetName();

		SetCurrentTask( destinationName );

		if ( q_Chapter1.GetStatus() == OBJECTIVE_PENDING )
		{
			if ( destinationName == "Treasure" )
			{
				CarrierStockUEC.AddItem( EGAMESTORAGE_COMMON, capsuleHack, 1 );
				g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );
			}

			if ( destinationName == "Frontier" )
			{
				CarrierStockUEC.AddItem( EGAMESTORAGE_COMMON, capsuleHack, 1 );
				RemoveRepairTutorial();
			}

			if ( destinationName == "Outpost" )
			{
				CarrierStockUEC.AddItem( EGAMESTORAGE_COMMON, capsuleHack, 1 );
				g_Game.SetTutorialHighlight( TH_HIGHLIGHT_NONE );
			}
		}

		if ( !CII_CountDownFinished && CII_CountDownStart )
		{
			if ( g_Game.GetCampaignDays() > CII_CountDown )
				CII_CountDownFinished = true;
		}
		
		return true;
	}

	//! Carrier arrived to destination island
	bool OnCarrierReachedDestination( IslandModel pCurrent, IslandModel pDestination )
	{
		if ( !CII_AuroraBack )
		{
			string islandName = pDestination.GetName()
			if ( islandName == "Bacchus" || islandName == "Taksaven" )
			{
				thread Start_chapII_AuroraBack( false, islandName );
				return false;
			}
		}

		if ( !dlg_adv_manualcarrierrepaired_anderson.IsFinished() )
		{ 
			if ( q_Chapter2.GetStatus() == OBJECTIVE_PENDING && pDestination.GetName() != "Fulcrum" )
				dlg_adv_manualcarrierrepaired_anderson.ToQueue();
		}
		return true;
	}

	//! On Island captured by player
	void OnIslandCaptured( IslandModel island, CCPlayer prevPlayer )
	{
		string islandName = island.GetName();
		CCPlayer islandOwner = island.GetPlayer();
		
		if ( q_Chapter2 )
		{
			if ( q_DeadZone.GetStatus() == OBJECTIVE_PENDING )
			{
				Objective objCurrent = GetIslandObjective( q_DeadZone, island );
				if ( objCurrent != NULL )
				{
					if ( islandOwner == PlayerAPA )
						objCurrent.SetStatus( OBJECTIVE_PENDING );

					if ( islandOwner == PlayerUEC && objCurrent.GetStatus() == OBJECTIVE_PENDING )
						objCurrent.SetStatus( OBJECTIVE_COMPLETE );
				}
			}
		}

		if ( islandOwner == PlayerAPA )
		{
			IslandsAPA += 1;
			SlotRestoration( island.GetName() );
			island.UniPostRestore();
			if ( prevPlayer == PlayerUEC )
				IslandsUEC -= 1;
		}

		if ( islandOwner == PlayerUEC )
		{
			if (!diskipadvisor)
				{
				diislcap++;
				diprogressunlock();
				}
			IslandsUEC += 1;
			if ( prevPlayer == PlayerAPA )
				IslandsAPA -= 1;

			//roll for new mission on Island
			int f = rand( 1,3 );
			if ( f == island.GetUniPostMission() )
			{
				f -= 1;	
				if ( f < 1 )
					f = 3;
			}

			island.UniPostClear();

			//pustme si viteznou muziku a najake kecy
			if ( g_Game.GetCurrentIsland() == island )
			{
				g_Game.PlayMusic( "music/track10", 1.0, 2.0 );
				PlayerUEC.ClearWaypoint();
				if ( !CampaignStart && q_Chapter3.GetStatus() == OBJECTIVE_PENDING )
					PlayIslandCaptured();
			}
			else
			{
				if ( !CampaignStart && q_Chapter3.GetStatus() == OBJECTIVE_PENDING )
					PlayIslandCapturedDistant();
			}

			//-----------------------------------CHAPTER2--------------------------------
			//-----------------------------------------------------------------------------
			if ( q_Chapter2.GetStatus() == OBJECTIVE_PENDING )
			{
				if ( IslandsUEC >= 6 && !CII_AuroraBack )
				{
					if ( !CheatStart )
						thread Start_chapII_AuroraBack( true, islandName );
					
					q_TechExploration.SetStatus( OBJECTIVE_PENDING );
					qCII_Evergreen_RC.SetStatus( OBJECTIVE_PENDING );
					qCII_Nemesis_RC.SetStatus( OBJECTIVE_PENDING );
					qCII_Beacon_RC.SetStatus( OBJECTIVE_PENDING );
					qCII_Endymion_RC.SetStatus( OBJECTIVE_PENDING );
					qCII_Taksaven_RC.SetStatus( OBJECTIVE_PENDING );
					qCII_Bacchus_RC.SetStatus( OBJECTIVE_PENDING );
					qCII_Granite_RC.SetStatus( OBJECTIVE_PENDING );
					qCII_Vattland_RC.SetStatus( OBJECTIVE_PENDING );
					qCII_Lingard_RC.SetStatus( OBJECTIVE_PENDING );
					qCII_Isolus_RC.SetStatus( OBJECTIVE_PENDING );
				}

				if ( IslandsUEC == 11 )
				{
					//Start Aurora camera
					CII_CountDown = g_Game.GetCampaignDays();
					CII_CountDown += 1.2;
					CII_CountDownStart = true;
				}

				//Setting Current Task For ChapterII
				if ( q_Chapter2.GetStatus() == OBJECTIVE_PENDING )
				{
					if ( RC_IsActive( islandName ) )
					{
						switch( islandName )
						{
							case "Evergreen":
								SetCurrentObjective( qCII_Evergreen_RC );
								SetCurrentObjectiveShiplog( qCII_Evergreen_RC );
								break;

							case "Nemesis":
								SetCurrentObjective( qCII_Nemesis_RC );
								SetCurrentObjectiveShiplog( qCII_Nemesis_RC );
								break;					

							case "Beacon":
								SetCurrentObjective( qCII_Beacon_RC );
								SetCurrentObjectiveShiplog( qCII_Beacon_RC );
								break;

							case "Endymion":
								SetCurrentObjective( qCII_Endymion_RC );
								SetCurrentObjectiveShiplog( qCII_Endymion_RC );
								break;

							case "Vattland":
								SetCurrentObjective( qCII_Vattland_RC );
								SetCurrentObjectiveShiplog( qCII_Vattland_RC );
								break;

							case "Lingard":
								SetCurrentObjective( qCII_Lingard_RC );
								SetCurrentObjectiveShiplog( qCII_Lingard_RC );
								break;

							case "Isolus":
								SetCurrentObjective( qCII_Isolus_RC );
								SetCurrentObjectiveShiplog( qCII_Isolus_RC );
								break;
						}
					}
				}
			}

			if ( islandName == "Evergreen" )
			{
				if ( qCII_Evergreen1st && qCII_Evergreen1st.GetStatus() == OBJECTIVE_PENDING )
					qCII_Evergreen1st.SetStatus( OBJECTIVE_COMPLETE );
			}

			if ( islandName == "Nemesis" )
			{
				if ( qCII_Nemesis1st && qCII_Nemesis1st.GetStatus() == OBJECTIVE_PENDING )
					qCII_Nemesis1st.SetStatus( OBJECTIVE_COMPLETE );
			}

			if ( islandName == "Beacon" )
			{
				if ( qCII_Beacon1st && qCII_Beacon1st.GetStatus() == OBJECTIVE_PENDING )
					qCII_Beacon1st.SetStatus( OBJECTIVE_COMPLETE );
			}

			if ( islandName == "Endymion" )
			{
				if ( qCII_Endymion1st && qCII_Endymion1st.GetStatus() == OBJECTIVE_PENDING )
					qCII_Endymion1st.SetStatus( OBJECTIVE_COMPLETE );
			}

			if ( islandName == "Granite" )
			{
				if ( qCII_Granite1st && qCII_Granite1st.GetStatus() == OBJECTIVE_PENDING )
					qCII_Granite1st.SetStatus( OBJECTIVE_COMPLETE );
			}

			if ( islandName == "Bacchus" )
			{
				if ( qCII_Bacchus1st && qCII_Bacchus1st.GetStatus() == OBJECTIVE_PENDING )
					qCII_Bacchus1st.SetStatus( OBJECTIVE_COMPLETE );
			}

			if ( islandName == "Taksaven" )
			{
				if ( qCII_Taksaven1st && qCII_Taksaven1st.GetStatus() == OBJECTIVE_PENDING )
					qCII_Taksaven1st.SetStatus( OBJECTIVE_COMPLETE );

				if ( !CII_CodeGainedI_Taksaven )
				{
					CII_CodeGainedI_Taksaven = true;
					if ( !CheatStart )
						thread Start_chapII_ResearchCodeGained1();
				}
			}

			if ( islandName == "Vattland" )
			{
				if ( qCII_Vattland1st && qCII_Vattland1st.GetStatus() == OBJECTIVE_PENDING )
					qCII_Vattland1st.SetStatus( OBJECTIVE_COMPLETE );
			}

			if ( islandName == "Lingard" )
			{
				if ( qCII_Lingard1st && qCII_Lingard1st.GetStatus() == OBJECTIVE_PENDING )
					qCII_Lingard1st.SetStatus( OBJECTIVE_COMPLETE );
			}

			if ( islandName == "Isolus" )
			{
				if ( qCII_Isolus1st && qCII_Isolus1st.GetStatus() == OBJECTIVE_PENDING )
					qCII_Isolus1st.SetStatus( OBJECTIVE_COMPLETE );
			}

			if ( islandName == CII_HMHDMissileLoc && !CII_CodeGainedI_Missile )
			{
				CII_CodeGainedI_Missile = true;
				if ( !CheatStart )
					thread Start_chapII_ResearchCodeGained1();
			}

			if ( IslandsUEC != 6 )
			{
				if ( islandName == "Nemesis" || islandName == "Evergreen" || islandName == "Beacon" || islandName == "Endymion" || islandName == "Granite" )
				{
					if ( RC_IsActive( islandName ) )
					{
						if ( !CheatStart )
							CTSV_chapII_ResearchCodeGained_noHMHD();
					}
				}
			}

			if ( islandName == "Vattland" || islandName == "Lingard" || islandName == "Isolus" ) 
			{
				if ( islandName != CII_HMHDMissileLoc && RC_IsActive( islandName) )
				{
					if ( !CheatStart )
						CTSV_chapII_ResearchCodeGained_noHMHD();
				}
			}

			//-----------------------END--OF--CHAPTER2--------------------------------

			//-----------------------------------CHAPTER3--------------------------------
			//-----------------------------------------------------------------------------
			if ( q_Chapter3.GetStatus() == OBJECTIVE_PENDING )
			{
				if ( !g_Game.IsObjectiveCompleted( qCIII_FindAurora ) )
				{
					int islandsAfterFulcrum = 0;
					if ( IsObjectiveCompleted( q_DuessaConq) )
						islandsAfterFulcrum++;
					if ( IsObjectiveCompleted( q_TerminusConq) )
						islandsAfterFulcrum++;
					if ( IsObjectiveCompleted( q_MedusaConq) )
						islandsAfterFulcrum++;
					if ( IsObjectiveCompleted( q_SanctuaryConq) )
						islandsAfterFulcrum++;
					if ( IsObjectiveCompleted( q_SomnusConq) )
						islandsAfterFulcrum++;
					if ( IsObjectiveCompleted( q_MilestoneConq) )
						islandsAfterFulcrum++;
					if ( IsObjectiveCompleted( q_GenetixConq) )
						islandsAfterFulcrum++;

					if (  islandsAfterFulcrum >= 3 && island == g_Game.GetCurrentIsland() && !CIII_AuroraFound )
					{
						if ( islandName == "Duessa" || islandName == "Terminus" || islandName == "Medusa" || islandName == "Sanctuary" || islandName == "Somnus" || islandName == "Genetix" || islandName == "Milestone" )
						{
							IslandAurora = IslandsUEC;
							qCIII_FindAurora.SetStatus( OBJECTIVE_PENDING );
							thread Start_chapIII_AuroraFoundPart1();
						}
					}
				}
				else
				{
					if( qCIII_ThermopylaeConq1st )
					{
						// if this objective is active and we are on thermopylae... aurora must have been played already
						if( qCIII_ThermopylaeConq1st.GetStatus() == OBJECTIVE_PENDING )
						{
							CIII_AuroraFoundPart2 = true;
						}
					}
				
					//Fix:: Kontainer zmizi kdyz dobudu ostrov na kterem je a prehraje se cutscena s Aurorou
					// Musime upodmikovat aby se to neprehravalo na tehle ostrovech CIII_ShieldLoc1 CIII_ShieldLoc2;
					if ( islandName != CIII_ShieldLoc1 && islandName != CIII_ShieldLoc2 )
					{
						if ( IslandsUEC >= IslandAurora + 2 && CIII_AuroraFoundPart2 && !dlg_CTSV_chapIII_MyrikHistory1.IsFinished() )
							CTSV_chapIII_MyrikHistory1();
						if ( IslandsUEC >= IslandAurora + 1 && !CIII_AuroraFoundPart2 )
							thread Start_chapIII_AuroraFoundPart2();
					}
				}

				if ( islandName == "Acheron" || islandName == "Styx" || islandName == "Hades" || islandName == "Naiades" )
				{
					if ( CIII_MyrikHistory2Played == "" )
					{
						IslandsMarshes += 1;

						if ( IslandsMarshes == 3 )
						{
							float r = frand( 0,1 );
							if ( r < 1 )
								thread Start_chapIII_MyrikHistory2();
						}

						if ( IslandsMarshes == 4 )
							thread Start_chapIII_MyrikHistory2();
					}
				}
			}
			//-----------------------END--OF--CHAPTER3--------------------------------
			if ( !CheatStart )
				SetCurrentTask( islandName );
		}
	}

	//! Island was lost
	void OnIslandLost( IslandModel island, CCPlayer prevPlayer )
	{
		CampaignLog("[CC:GM] >>> OnIslandLost - no code yet.", 3);
	}

	//! Solve island revelation
	void OnIslandRevelation( IslandModel pIsland )
	{
		bool reveal = false;
	
		if( pIsland.GetPlayer() == PlayerUEC )
		{
			reveal = true;
		}
		else
		{
			if( pIsland.IsConnectedToEnemy() )
				reveal = true;

			if( pIsland.IsBuildingCommandCenterForPlayer() )
				reveal = true;
	
			if( pIsland == g_Game.GetCurrentIsland() )
			{
				if ( PlayerUEC.GetCarrier() != NULL )
				{
					vector carPos = PlayerUEC.GetCarrier().GetPosition();
					vector islPos = pIsland.GetPosition();
					vector distVec = carPos - islPos;
					distVec[2] = 0;
					float dist = VectorLength( distVec );
					if ( dist < 256000 )
						reveal = true;
				}
			}
		}
			
		if( reveal )
			pIsland.OnRevealed();
		else
			pIsland.OnConcealed();
	}


	//! Stockpile was set
	void OnStockpileSet( IslandModel pStockpile, CCPlayer pPlayer )
	{
		CampaignLog("[CC:GM] >>> OnStockpileSet - no code yet.", 3);
	}

	//! Stockpile was lost
	void OnStockpileLost( IslandModel pStockpile, CCPlayer pPlayer )
	{
		CampaignLog("[CC:GM] >>> OnStockpileLost - no code yet.", 3);
	}

	//! Island's pier was destroyed
	void OnPierDestroyed( IslandModel island )
	{
		CampaignLog("[CC:GM] >>> OnPierDestroyed - no code yet.", 3);
	}

	//! Island's pier was repaired
	void OnPierRepaired( IslandModel island )
	{
		CampaignLog("[CC:GM] >>> OnPierRepaired - no code yet.", 3);
	}

	//! Island's slot was destroyed
	void OnSlotDestroyed( IslandModel island )
	{
		CampaignLog("[CC:GM] >>> OnSlotDestroyed - no code yet.", 3);
	}

	//! Island's slot was repaired
	void OnSlotRepaired( IslandModel island )
	{
		CampaignLog("[CC:GM] >>> OnSlotRepaired - no code yet.", 3);
	}

	//! Called then some of Buildings destroyed
	void OnBuildingDestroy( Building pBuilding )
	{
		GenericBuildingDestroyed( pBuilding );
	}

	//! Specific building being hacked
	void OnBuildingHacked( Building pBuilding, CCPlayer pByPlayer )
	{
		int bType = pBuilding.GetBuildingType();
		Activator activator = pBuilding.GetActivator();

		if ( bType == BuildingFactory || bType == BuildingRefinery || bType == BuildingHeadQuarters )
		{
			CCGMBuildingHacked( bType, false );
			if ( activator )
				SlotActivatorUsed( activator, g_Game.GetCurrentIsland().GetName() )
		}
		GenericBuildingHacked( pBuilding, pByPlayer );
	}

	// Entity discovered on map
	void OnDiscovered( InteractiveEntity entity )
	{
		GenericOnDiscovered( entity );
	}

	//! Called before game is saved
	void OnBeforeSave()
	{
		OnBeforeSaveBase();
	}

	//! Called after game is loaded from save
	void OnAfterLoad()
	{
		OnAfterLoadBase();
		// set global pointers for production
		GainProduction();
	}

	//! Callback to game code - median unit skill
	float GetUnitSkill()
	{
		return UnitSkill;
	}

	//! Callback to game code - unit skill range (returned number will form an interval along with the above func)
	float GetUnitSkillRange()
	{
		return UnitSkillRange;
	}

	//! Callback to game code - current power multiplier
	float GetGlobalForceMultiplier()
	{
		return MultiForce;
	}

	//! Callback to game code - current preferred tech level
	int GetCurrentTechLevel()
	{
		if ( q_Chapter2.GetStatus() == OBJECTIVE_COMPLETE && !diiru )
			return TechLvl;
		else
		{
			if ( q_Chapter1.GetStatus() == OBJECTIVE_COMPLETE )
				return 1;
		}

		return 0;
	}

	//! Get island objectives to array
	int GetIslandObjectives( IslandModel island, Objective objectives[32] );

	//! Get island defense power and write to island info screen
	string GetIslandDefenseLabel(IslandModel island )
	{
		string label;
		if ( q_Chapter2.GetStatus() == OBJECTIVE_PENDING && !diiru )
		{
			string islandName = island.GetName();
			switch( islandName )
			{
				case "Nemesis":
					if ( !IsObjectiveCompleted( qCII_Nemesis1st ) )
						label = "#island_prop_defense_value_weak";
					break;
				
				case "Evergreen":
					if ( !IsObjectiveCompleted( qCII_Evergreen1st ) )
						label = "#island_prop_defense_value_weak";				
					break;
				
				case "Beacon":
					if ( !IsObjectiveCompleted( qCII_Beacon1st ) )
						label = "#island_prop_defense_value_good";
					break;
				
				case "Endymion":
					if ( !IsObjectiveCompleted( qCII_Endymion1st ) )
						label = "#island_prop_defense_value_good";
					break;

				case "Bacchus":
					if ( !IsObjectiveCompleted( qCII_Bacchus1st ) )
						label = "#island_prop_defense_value_good";

				case "Taksaven":
					if ( !IsObjectiveCompleted( qCII_Taksaven1st ) )
						label = "#island_prop_defense_value_good";
					break;

				case "Granite":
					if ( !IsObjectiveCompleted( qCII_Granite1st ) )
						label = "#island_prop_defense_value_good";
					break;

				case "Vattland":
					if ( !IsObjectiveCompleted( qCII_Vattland1st ) )
						label = "#island_prop_defense_value_strong";
					break;

				case "Lingard":
					if ( !IsObjectiveCompleted( qCII_Lingard1st ) )
						label = "#island_prop_defense_value_strong";
					break;

				case "Isolus":
					if ( !IsObjectiveCompleted( qCII_Isolus1st ) )
						label = "#island_prop_defense_value_strong";
					break;

				case "Fulcrum":
					if ( !IsObjectiveCompleted( qCII_FulcrumConq1st ) )
					{
						if ( !IsObjectiveCompleted( qCII_HMHD )
							label = "#island_prop_defense_value_deadly";
						else
							label = "#island_prop_defense_value_strong";
					}
					break;
			}
		}
		else
		{
			if ( ShowIslandInfo( island )	)
				label = GenericDefenseLabel( island );
			else
				label = "#island_prop_defense_value_unknown";
		}

		ShowIslandSourcesQuality( island );

		string str = island.GetName() +  ": Island Info screen: "
		CampaignLog( str , 3);
		CampaignLog( label, 3);
		return label;
	}

	//! Called then UniPost event is generated
	void OnUniPostEvent( UniPost pUniPost, int eEvent, int iRemain, int iTotal )
	{
		Objective currentObjective = NULL;

		IslandModel island =  g_Game.GetCurrentIsland();
		Objective islObjective = GetIslandObjective( q_DeadZone, island );
		if ( islObjective != NULL )
		{
			Objective islObj = islObjective.GetSubObjective( 0 );
			if ( islObj )
				currentObjective = islObj;
		}

		string islandName = island.GetName();
		int tst =  strstr( g_Game.SpawnLayerName( g_Game.GetSpawnLayer() ), "First")
		if ( tst > -1 )
		{
			switch( islandName )
			{
				case "Evergreen":
						currentObjective = qCII_Evergreen1stRand;
					break;

				case "Nemesis":
						currentObjective = qCII_Nemesis1stRand;
					break;		

				case "Beacon":
						currentObjective = qCII_Beacon1stRand;
					break;

				case "Endymion":
						currentObjective = qCII_Endymion1stRand;
					break;

				case "Granite":
						currentObjective = qCII_Granite1stRand;
					break;
			}
		}

		GenericUnipostMission( pUniPost, eEvent, iRemain, iTotal, currentObjective );
	}

	//! Event whenever carrier storage recieves some items
	void OnCarrierStorage( int eStorageType, int eDBEnum, int iCount )
	{
		if ( BanGameMessage )
			return;
		
		if( eStorageType == EGAMESTORAGE_BARQUE || eStorageType == EGAMESTORAGE_OBJECTIVE || eStorageType == EGAMESTORAGE_STOCKPILE )
		{
			if ( IsItemCarrierEquipment( eDBEnum ) )
				g_Game.GetControlledPlayer().GetCarrier().AddEquipment( eDBEnum );
			disetarticlename( eDBEnum );
			g_Game.AddMessage( "#item_was_added_carrier", COLOR_YELLOW, LMF_EMPIRE, diarticlename );
		}
	}

	//! Event whenever item is produced and transfered to players storage
	void OnItemProduced( int eDBEnum, int iCount )
	{
		g_Game.PlayGameSound("Game/radio/strategy/production_complete" );
		disetarticlename( eDBEnum );
		g_Game.AddMessage( "#item_was_created" , COLOR_YELLOW, LMF_EMPIRE, diarticlename );
		
		if ( !Tut_FirstItemProduced )
		{
			Tut_FirstItemProduced = true;
			if ( q_Chapter1.GetStatus() == OBJECTIVE_PENDING )
				dlg_prs_adv_Stockpile_Anderson.ToQueue();
		}
	}

	//! Called when carrier was attacked
	void OnCarrierAttacked( Carrier pCarrier )
	{
		EvaluatingCarrierAttack--;						//decrease lock
		if( EvaluatingCarrierAttack >= 0 )		//lock 
		{
			if ( pCarrier.GetPlayer() == PlayerAPA )
			{
				if ( IsObjectiveCompleted( q_Chapter2 ) )
				{
					Carrier carrierAPA = PlayerAPA.GetCarrier();
					Carrier carrierUEC = PlayerUEC.GetCarrier();
					
					if ( pCarrier.GetHealth() <= 0.8 && !g_Game.IsCutscenePlaying( CARRIERBEATOFF_CUTSCENE ))
					{
						CampaignLog( "[CC:GM] >>> Player beat off enemy carrier." );
						vector oriCarr = pCarrier.GetOrientation();
						vector ori = Vector(oriCarr[1], oriCarr[0], oriCarr[2]);
						if( carrierAPA )
							carrierAPA.SetCaptive( true );
						if( carrierUEC )
							carrierUEC.SetCaptive( true );
						CARRIERBEATOFF_CUTSCENE = g_Game.PlayCutsceneOnPos("cutscenes/chapIII/ctsc_chapiii_carrierbeatoff.cut", pCarrier.GetPosition(), CPM_NORMAL, false, false, ori );
						g_Game.FadeIn( 50 );
						Sleep( 100 );
						Wait( !g_Game.IsCutscenePlaying( CARRIERBEATOFF_CUTSCENE ) )
						g_Achievements.OnCarrierFenceOff();
	
	//Znic apacke jednotky na konci cutsceny
	
						EntityBasic assemblies[8];
						int arraySize = PlayerAPA.GetAssemblies( assemblies );
		
						for( int xLoop = 0; xLoop < arraySize; xLoop++ )
						{
							EntityBasic assembly = assemblies[xLoop];
							if ( assembly )
							{
								if( assembly.IsWalrus() || assembly.IsManta() )
								{
									InteractiveEntity pEntity = assembly.GetEntity();
									if( pEntity )
										pEntity.Destroy();
								}
							}
						}
	
						carrierUEC = PlayerUEC.GetCarrier();
						carrierAPA = PlayerAPA.GetCarrier();
						if( carrierAPA )
						{
							carrierAPA.DefenseDronesDock();
							carrierAPA.SetCaptive( false );
						}
						if( carrierUEC )
							carrierUEC.SetCaptive( false );
						IslandModel isl = NULL;
						if ( g_Game.GetCurrentIsland().GetName() != "Genetix")
							isl = g_Game.FindIslandByName("Genetix");
						else
							isl = g_Game.FindIslandByName("Hades");
	
						
						if( carrierAPA )
							carrierAPA.OnToDockPoint(isl);
						g_Game.SendCarrierToIsland( PlayerAPA, g_Game.GetCurrentIsland().GetArea() );
						if( carrierUEC )
							carrierUEC.SelectForPlayer();
						if ( CIII_ShinContact == 0 )
							dlg_CTSV_chapIII_ShinContactsMyrik.ToQueue();
	
						CIII_ShinContact += 1;
					}
				}
			}
			EvaluatingCarrierAttack = 1;	//restore lock
		}
	}

	//! Player switching to map
	void OnSwitchToMap()
	{
		Print( "[CC:GM] >>> OnSwitchToMap!!!.");

		if ( dlg_hint_Tutorial_MapViewIslandZoom.IsPlaying() )
			dlg_hint_Tutorial_MapViewIslandZoom.Stop();

		if ( g_Game.GetCurrentIsland().GetName() == "Vulcan" )
		{
			if ( dlg_adv_Tutorial_CarrierView_Anderson.IsPlaying() )
				dlg_adv_Tutorial_CarrierView_Anderson.Stop();

			if ( dlg_adv_Tutorial_CarrierView_Anderson_Joy.IsPlaying() )
				dlg_adv_Tutorial_CarrierView_Anderson_Joy.Stop();	

			if ( IsObjectiveCompleted( q_Vulcan) )
			{
				if ( !dlg_adv_Tutorial_Map_TacticAndStrategicZoom.InMainQueue() && !dlg_adv_Tutorial_Map_TacticAndStrategicZoom.IsFinished() )
				{
					dlg_adv_Tutorial_Map_TacticAndStrategicZoom.ToQueue();
					if( g_Game.JoypadPreferred() )
						dlg_hint_Tutorial_MapViewIslandZoom_Joy.ToQueue();
					else
						dlg_hint_Tutorial_MapViewIslandZoom.ToQueue();
				}
			}
		}
		else
		{
			if ( dlg_hint_Tutorial_MapViewIslandZoom.IsFinished() && !Tut_Con_GetPlanned )
			{
				if ( g_Game.JoypadPreferred() )
					dlg_con_adv_GetPlanned_Okoro_Joy.ToQueue();
				else
					dlg_con_adv_GetPlanned_Okoro.ToQueue();
			}
		}
	}

	//! Player switching to action (direct mode)
	void OnSwitchToAction()
	{
		if ( !Tut_Con_GetPlanned && dlg_con_adv_GetPlanned_Okoro_Joy && dlg_con_adv_GetPlanned_Okoro)
		{
			if ( !dlg_con_adv_GetPlanned_Okoro_Joy.IsPlaying() )
				g_ActionQueue.RemoveAction( dlg_con_adv_GetPlanned_Okoro_Joy );

			if ( !dlg_con_adv_GetPlanned_Okoro.IsPlaying() )
				g_ActionQueue.RemoveAction( dlg_con_adv_GetPlanned_Okoro );
		}
	}

	//! Called when player try to leave island with units
	void OnDropDeployedUnits()
	{
		if ( q_Chapter1.GetStatus() == OBJECTIVE_COMPLETE )
		{
			int assemblyCount = 0;
			EntityBasic assembly;
			for( int i = 1; i < 9 ; i++)
			{
				assembly = g_Game.GetControlledPlayer().GetAssembly( i );
				InteractiveEntity ent = assembly.GetEntity();
				if ( ent != NULL && ent.GetHealth() > 0)
				{
					if ( !ent.IsDocked() )
						ent.Destroy();
				}
			}
		}
	}

	//! Called when action begins upon particular building
	void OnAction4Building( Building pBuilding )
	{
		GenericAction4Building( pBuilding );
	}

	//! On Game event that should be also handled by script
	//for more see file GM_GameEvent
	void OnGameEvent( string sPlayerEvent );
	

	//! On carrier unit game event
	void OnCarrierUnitEvent( InteractiveEntity pUnit, string sEventName )
	{
		if ( pUnit.GetPlayer() != PlayerUEC )
			return;

		switch( sEventName )
		{
//------------------------------------------------------------------------------------------------------------------------

			//vyber jednotky nebo carrieru
//			case "select":
//
//				break;

//			case "dock":
//				
//				break;

//			case "undock":
//
//				break;

			case "waypoint":
				if ( !Tut_Con_Waypoint )
				{
					Tut_Con_Waypoint = true;
					dlg_con_adv_SuspendExec_Okoro.ToQueue();
				}
				break;

			case "lowfuel":
				if( !Tut_Gen_ReplenisherFuel )
				{
					Print( "lowfuel nastal");
					Tut_Gen_ReplenisherFuel = true;
					Tut_Wal_FuelLow = true;
					dlg_con_adv_LowFuel_Okoro.ToQueue();
				}
				break;

			case "lowammo":
				if ( !Tut_Wal_AmmoLow )
				{
					Tut_Wal_AmmoLow = true;
					dlg_con_adv_LowAmmo_Okoro.ToQueue();
				}
				break;	
					

//			case "destroy":
//
//				break;

		}

//    cam_extern  - kamera v carrieru (externi)
//    cam_cannon  - kamera v carrieru (turret)

	}

	//! When players captures all islands
	void OnAllIslandsCaptured()
	{
	}
	
	//! Barque was docked to carrier event
	void OnBarqueDockToCarrier()
	{
		if ( !Tut_FirstBarqueArrived )
		{
			Tut_FirstBarqueArrived = true;
			dlg_sps_adv_SuppliesScreen_Anderson07.ToQueue();
		}
		GenericBarqueDockToCarrier();
	}

	//! When strategy map distribution is about to be created
	void OnStrategyMapCreate()
	{
	}

	//! When strategy map distribution needs to be initiated
	void OnStrategyMapInit()
	{
		g_Game.ClearIslandLinks();

		// create links
		// First chapter
		g_Game.CreateIslandLink( "Vulcan", "Arachnid" );
		g_Game.CreateIslandLink( "Arachnid", "Treasure" );
		g_Game.CreateIslandLink( "Treasure", "Frontier" );
		g_Game.CreateIslandLink( "Frontier", "Outpost" );

		//Second Chapter
		g_Game.CreateIslandLink( "Outpost", "Nemesis" );
		g_Game.CreateIslandLink( "Outpost", "Evergreen" );
		g_Game.CreateIslandLink( "Nemesis", "Beacon" );
		g_Game.CreateIslandLink( "Beacon", "Evergreen" );
		g_Game.CreateIslandLink( "Beacon", "Bacchus" );
		g_Game.CreateIslandLink( "Beacon", "Endymion" );
		g_Game.CreateIslandLink( "Bacchus", "Granite" );
		g_Game.CreateIslandLink( "Granite", "Taksaven" );
		g_Game.CreateIslandLink( "Granite", "Vattland" );
		g_Game.CreateIslandLink( "Vattland", "Lingard" );
		g_Game.CreateIslandLink( "Vattland", "Isolus" );
		g_Game.CreateIslandLink( "Endymion", "Taksaven" );
		g_Game.CreateIslandLink( "Endymion", "Fulcrum" );
		g_Game.CreateIslandLink( "Evergreen", "Fulcrum" );
	
		//Third Chapter
		g_Game.CreateIslandLink( "Fulcrum", "Duessa" );
		g_Game.CreateIslandLink( "Fulcrum", "Naiades" );
		g_Game.CreateIslandLink( "Naiades", "Milestone" );
		g_Game.CreateIslandLink( "Duessa", "Acheron" );
		g_Game.CreateIslandLink( "Duessa", "Terminus" );
		g_Game.CreateIslandLink( "Terminus", "Acheron" );
		g_Game.CreateIslandLink( "Terminus", "Medusa" );
		g_Game.CreateIslandLink( "Medusa", "Sanctuary" );
		g_Game.CreateIslandLink( "Medusa", "Somnus" );
		g_Game.CreateIslandLink( "Acheron", "Styx" );
		g_Game.CreateIslandLink( "Styx", "Hades" );
		g_Game.CreateIslandLink( "Styx", "Milestone" );
		g_Game.CreateIslandLink( "Milestone", "Thermopylae" );
		g_Game.CreateIslandLink( "Magma", "Thermopylae" );
		g_Game.CreateIslandLink( "Obsidian", "Thermopylae" );
		g_Game.CreateIslandLink( "Fornax", "Thermopylae" );
		g_Game.CreateIslandLink( "Avernus", "Thermopylae" );
		g_Game.CreateIslandLink( "Milestone", "Thermopylae" );
		g_Game.CreateIslandLink( "Milestone", "Genetix" );
		g_Game.CreateIslandLink( "Genetix", "Thermopylae" );		

	}
	//@}

	/*****************************************************
				Defenses on Vulcanic Islands - DIALOGS
	*****************************************************/

	void PlayFirstPowerPlantFoundDialog()
	{
		if( CIII_VolcanicShields == 0 )
			dlg_FirstPowerPlantFound.ToQueue();

	}
	
	void PlayDefenseDisabledDialog()
	{
		switch( CIII_VolcanicShields )
		{
			case 1:
				dlg_FirstShieldDefenceDisabled.ToQueue();
				break;
			
			case 2:
				dlg_FourthShieldDefenceDisabled.ToQueue();
				break;
		}
	}
};
/**@}*/

#include "scripts/Campaign/GM_AfterWorldLoad.h"
#include "scripts/Campaign/GM_BeforeWorldLoad.h"
#include "scripts/Campaign/GM_EnterCampaign.h"
#include "scripts/Campaign/GM_GetIslandObjectives.h"
#include "scripts/Campaign/GM_ObjectiveCompleted.h"
#include "scripts/Campaign/GM_GameEvent.h"

